/*******************************************************************************
+
+  LEDA 7.0  
+
+
+  gw_planets.c
+
+
+  Copyright (c) 1995-2023
+  by Algorithmic Solutions Software GmbH
+  All rights reserved.
+ 
*******************************************************************************/


#include <LEDA/graphics/graphwin.h>
#include <LEDA/graphics/pixmaps/texture/space.xpm>
#include <LEDA/system/file.h>

using namespace leda;

/* XPM */
static const char *deep[] = {
/* width height num_colors chars_per_pixel */
"    72    65       41            1",
/* colors */
". c None",
"# c #330000",
"a c #003300",
"b c #333300",
"c c #000033",
"d c #330033",
"e c #003333",
"f c #333333",
"g c #663333",
"h c #336633",
"i c #666633",
"j c #996633",
"k c #669933",
"l c #999933",
"m c #333366",
"n c #663366",
"o c #336666",
"p c #666666",
"q c #996666",
"r c #669966",
"s c #999966",
"t c #cc9966",
"u c #99cc66",
"v c #cccc66",
"w c #ffcc66",
"x c #666699",
"y c #999999",
"z c #cc9999",
"A c #99cc99",
"B c #cccc99",
"C c #ffcc99",
"D c #ccff99",
"E c #ffff99",
"F c #cccccc",
"G c #ffcccc",
"H c #ccffcc",
"I c #ffffcc",
"J c #ccccff",
"K c #ffccff",
"L c #ccffff",
"M c #ffffff",
/* pixels */
"..c..c..c..c.....c..c.c...c..e.c.....cbcf.c.e.cbc.f..f...e.c.f....c.e#.c",
"ca.c.e..c.e..c.cad..f..eda.fc#c.fcbcafcf..ff.f.cbfeff.fcf#cbe.facfb.c.e.",
".c.c#..c.f.c.a#c.....e.d.c...f.caff.da.ffef..fabfcb.fcfafcafd.f.def.f.#f",
"....c.cb....d..a..e...f..f.cf.ef.caf.c.fc#ef.f#e#ec..ffc..ffcbc.ad..e.c.",
"c.c.e..e.c.c..e.cb.f.fcf.cadac#e#c..fafmf..f.fff.fbcfe..bcf.c..f..fcbcbc",
"..ad.c#c.d..e....dc....fe..edadecf.f.fc.fafff.a.fc..e#f..e.f.ed.e.a.c..c",
"..c...e..e.cb..cfe#.ede..cf.c.f.ff..ff.cfcbcfcd.afc.bc.fc#cacdaf.cf.ff..",
".c..e..c.c..ccf.c.e.cbc.f..f.ed.f.effcbfbc.cfafc.fade#.e..f.c.ccb.f..cfe",
"....d..d.ad..e.c.e.cc.ec..fc.b.em..#.f.f.f.i.dfe.f.f.ef.a.ffcfe.cbc.eb..",
"c.cac..e..ed.f..f#edadefcf.fffodafs.effff.ffffbf#o#.bc..dc.f...f.c.f.de#",
"..cbc..f.c...c.cad..c.#.afcbe.ffgoffqhifnipififacbff.d.ef....f.c#a..cbe.",
".c.c....cbc.ef..cbcef.Mx#ff.gfiffbghifpsppppphghnfe.f..c.afcede.cbcf..c.",
".c.a.dac..f.c.e..f.f.fypafffpfpppfbpipqppsqrjqhiffpfff.fcf..#.c.b..ff...",
".e#c.c...c..ffdafffe.ffbffpififgpqsptyszBqipssqipigofdfc...fef.ed.c...fe",
"..c..f.e#e..c..da.ghfgfpfpfghppissitssBssBBsipsqppfgfanfffe...c.a.efcbcf",
".c..cac.c#efcbcbdfodfanbpifpspiiiBCBtBtsjBsvCspsipiiffhc...c.de#c..#e...",
".fca#cb.f..cfcbcfbfbffiffpigpiqtvBvBBBlsCsjszsjisqpppfp#.fcff.c.c..efdac",
".c.ca..c.e.f..e#afffbpfhfppiiqvBtvzlvCBzissspsppsrghgfcffcf...feded.f.c.",
"....d.cb...fbf.fffbfpffghgiiiBBBBBBBGszssyiqysplpippificf.ff..cb..cac.f.",
".e..e..ec#ecc.f.ffffffghnhgsstBBCzvBBqssqsspipiipgipfpfgaf..e..c.cf..cad",
"..d.c#c...cf.f#e.ffifffpfiplszBvGByBzvssqipipifpipipgpbfpff.dac.f..cf..f",
".ca.ca.c.f.c.bcfffffdhpgipiBCuBtBBCyBzitAjspiiyqsppifhffffe..cb.fc..f.c.",
"c..d.c.f.f..efffffffffnpiystBBBBIMIIIBCBipispgihpighpgffb..dfac.c.c..ca.",
".e.e....e.cffd.bffffffihbsCBBCIIMIMMMIMBvsiqipfippinfifffda.c.cf.a.e.d.c",
".d...e.d.fda.bma.ibfiogpiBvBIIIGMMMMMIMIIqiihpipiipiimfff.e#e#e.d.c#e.e.",
"..e#c#e.f..cfcbfpfffgfhsiBCBGIMMMMMMLMIIIBipigifipgpfifmff.fed.c.eb.c..d",
"...c.e...c.af#cef.gmhgpijEIIMMMLMKLKIMLGIBsiipfipiphgc.f.fe#.af.c.cf.d.a",
".c.ac#edadadeffffphffpilBIEMMMMMLMMMMMMICIvpipghnpigopmffa.f.c.cbc...e.d",
".c.c.f..cada.fadffffpfpzDBGIMMFMIKMMFMMFICBiiffqhffib.ffffcff...c..fc.c.",
".cbc.c.e.f.c.fffbfffgiisIIIMMMMIMMLMMMMIBCuqfpppgpiMMiff.ff.e#e..fc...f.",
"..cf..f..defffffpfgfipqsIIMMKMLMMGMMKMMIEFvqrfifhgrMMfbffeda.c.c.c.e.c..",
".ca.c..cbc.#efdfffbhgisBIIMGMMMIJMMMHMMICBipigpifpigfifcm..f.f..f..#.ad.",
"c.de#.c..ffeffffbpfipiiIIGMMLMJIMMLKMMMIEBjsfphp#piifffff...c.fc.cac....",
"..e..cfef..cfffffbpifitBIIMMMMMMMMMMMMLGCuBqhdiiiipfhpmff.e#f..ca..f..ed",
"...de...debcf.finhgfiizIIIMMLMMHKMJMIMGHCsyiifimipif#mf.ff..e.c.dc.f..c.",
".c...e.cad.bffffhffffisIIIMKMLGMMMMLMIFEBsqpbpfpfippffi.feded.f..e#c....",
"..e.c#c..cbedh#fgfiffisCMIILMMMMLMMIMIBvCthiibpgppfgihdf..f.ac.ce#c.cada",
"...dacac.fcffbmhpfifigsBIIKIMLKMMMMMEECwvqsnffshinihnfacfafc#e......e#.c",
"c.fc.c#cff.bcffgfpifpbpvIIMMKMMMLGMIGBvEsrghgpfigiogfffef.#e.#.c.f.c..e.",
".f...ef.e.fffffhghnihgszIIIMIMIMIMIFlBvjsjpppipippipffd.f.e#e..a..c.c...",
"..cac.c.cbd..fffhfpippikCIIMIMHIIIGBsBCBipfnpfipipfgfe#ecbca.c.dcac.b...",
"...cbc.f.efebfifnbipipqijBBBIIGEFvvzvCBspqpiiippgighffff.f.d...e.#c.c.e.",
"cac.cace.dffffmfhpffpirilltBzBssCtBCBBBjsiipiiqpsiffip.f.c..ec...c.f..d.",
".d.cbc#.f.fadfffifipipiiplBtvszvBBCEBvBjrqsiliispgifbda.fc..d..fca.cf...",
"ca....ec.cfcbfffgfpppgpppssBBttIBBBCBBzrjiipsqpipffeded.cffc.e...c.....e",
".c.e#c.d.af..fffhniiippplzsvzBBCICEIvsissqspipFifpffaf.daccbed...adaca.x",
".ad..acad..ffdffghgoqpsspvqBCvIBCBvyBqqiispisfpgpaf.f#cf...c..efc#..c...",
".c.eda.c.edefaffhgfiippqssvBtvCBsBGsjsssypipfqifff#e#e...fcad..ca.c..c..",
".f..cda.d.af.fffffippfqrqytBBCABCBsqhqpisigiffffff.f..c..c.ca...c..ad..c",
"c.ad..c.acd..ffffimfppipssssBBGBzrgpsfipifpfgefff.fc.e#e.f..de.c.f.ca.f.",
"..ce.cbc.bce.fff#ogfigpiipyssipiiipifippfbffhdbcadca..f..cf.e.c.ac...c.e",
".e#ede.cbcbcd.f..icbfpihpgifgpibfpfpfp.bfgoffff.fcad..cb.e...da.d.e#c..d",
".c.fc.f.f.cfe.ff.fffffffbffhfifffpfffbfffff#ade#.f..cf.c...c..c...c.....",
"cbc.f.ede.fcbc.c.edac..ffffmfcfifbfhfffffe.ff..f.c.e..f..c..cf.c.c..e.c.",
".e.cac..fce#.ef.cbcfffff.fff#fafffbd.bff.f#e#.f..e#c..c.f.cb...f....d...",
".c#e#c.c.f.ec#e#e#ef.f.fffffef#.hfffffca#eff.e..d.e..f...cac.c.c.c.e.ac.",
"..efcf.f.ededacfcadacbfcade#ffffdfef.ffffc..cbca.cbc..c..fc..c.f.e#c#.cb",
"c.de#ecf.c.#e.fdadedac.f#effcfe.ff#e.mf.cbef.f..f...ca...c...f...c...c..",
".e.ce#.edfefd.edfcffdfafdf.f.fffffedfcbcadc#.c.c..cbcd.f..f.c.c.c.f..ac.",
".cbc#e...e..fc.edaf.efdfeffcffcifffcfffccbec.e#e..c....cf..ca.f..c..c.f.",
".c.f.cfce#ceffcbcf.fcbedecadff.fccfacffe#c.e.d.eda...ed..c.c.c.c..e.e...",
"cbece..fcbc#cfcfe#efdefcf#feffcfhf.df.c.ef.cf.c.c#.fc.ae....cb..cbc...fc",
".cb.dacb.f.e.f.fdedcff.ffeffcfebc.fefcf.fc.c.e..ec...c..cac.ac.ca..d.c..",
".f.ce#e.decbcpcacffffedf.mfcfmfeffcf.c..cbcad.f..ece..c...#e#..#c...e.cb",
"c.e.dcccfcfcepfmfmmefmfmffffffcfff.fcffcac.cac.c.f..da..f.c..ce..ede...c"
};

/* XPM */
static const char *earth[] = {
/* width height num_colors chars_per_pixel */
"    68    72       46            1",
/* colors */
". c None",
"# c #003300",
"a c #333300",
"b c #000033",
"c c #330033",
"d c #003333",
"e c #333333",
"f c #336633",
"g c #000066",
"h c #330066",
"i c #003366",
"j c #333366",
"k c #663366",
"l c #006666",
"m c #336666",
"n c #666666",
"o c #996666",
"p c #999966",
"q c #000099",
"r c #003399",
"s c #333399",
"t c #663399",
"u c #336699",
"v c #666699",
"w c #996699",
"x c #669999",
"y c #999999",
"z c #cc9999",
"A c #99cc99",
"B c #cccc99",
"C c #6633cc",
"D c #3366cc",
"E c #6666cc",
"F c #9966cc",
"G c #6699cc",
"H c #9999cc",
"I c #cc99cc",
"J c #99cccc",
"K c #cccccc",
"L c #ffcccc",
"M c #ccffcc",
"N c #cc99ff",
"O c #ccccff",
"P c #ffccff",
"Q c #ccffff",
"R c #ffffff",
/* pixels */
"....................................................................",
"....................................................................",
"..........................bbjjjsmvvjmje.............................",
"........................bijjjsmssnsvvvsvvme.........................",
"......................gijjsjsjsjussusvvGyHHvnd......................",
"....................bgjjtnvvuussjruvvvvyEyHHHyvd....................",
"..................bbijijsuvyvwvuusnvvGvHvHwyHHyHmb..................",
".................bbihjjjukutmuvvvusvvvvvvvGvHxEvEyj.................",
"................bbijjijsnusyvvvvyyvvvHHHHyHvHyHwGvEx................",
"...............bgjijjsjisjwxHyvHyHvusyxvuvvHyHHHvxFyGe..............",
"..............bbjjjjrjrgujsjvvHvuvuvsusssrrrrsvyGHyHwGe.............",
".............bbjjijsjisjsjrivxyvvsjsjusvvvjssissssxEyHHj............",
"............bbjjjsjjsjsmujsitsvsjyvvHnsxvvvuvsursrvsvGwHj...........",
"............bjjjvmvujujvvHyHyuvvyEyxvujvwHvuvvvxssuuvsuxHe..........",
"...........bbjmjukvjvvyHwxHwHyIJKvyvjsnHyyxwvutusussuvsEyGc.........",
"..........bbjmtjvmtunuwxvvvJyHKHyvvsjjrxwGHHsvusususvuvuCxv.........",
"..........bjjjnukvmskvvvvvvyHvvvvjijrmtvxvyyyvvvvssvuvvvuEHv........",
".........bgejsmvvnsjusmwvxwvHvmwvusjvvmvvvyHvHxvvvuutvuvvFxHd.......",
".........bigjjjjsjsjsnusjsmvKvjvunslyusvvyHHHyHvvvyvusvsvHHyF.......",
"........bbijijsjjsmvnvsjsjvvHyvyvvyEvvnvHJyKKIyvvExHvvuvEyHHxj......",
"........bgbjgiijukuvsjvvmvvjsjvnHvyHyHHyyHIKOOJwuuwHHvvuvvvHGyb.....",
".......bbdgijjjrnvwvmvvvysvuvjuHKKHKKOKKEyJKOLOyvsuvvHyEvvGvHwm.....",
".......bbgjjjsvjvvxvtxvysvHIyvvyKOyHKKPKKHKIOMPJHysuvvEKyvvEvyF.....",
".......bgdjijvvwuvvyjvsvyHAHJytvvIKJIKKOHKKKOKKHHyvssuvvHHvvvEyj....",
"......bbijjjjunvvnsvvunvHwHzHHvjvnxIKKHHKKOKOKHyHyvvusjuvGyDvvyv....",
"......bbjgjiskunwvvvyvtxyHJHyvyvsvnyOKHxIKOKKKHHKHyvvsussvvHHvEy....",
"......bbijjjjukvuvmsvvvuvvvvwJHyvvvwKQKOHHKKOKKHHyHvovssusvHKHxFe...",
"......bihjjjjjsmsnvjjvvvvnvvvvvyHynvyOLOMHHKOOKKKHyHvvujsuvvxvHvu...",
".....bbbjijirjgsjsjrjrjvvtukvuguyHvoyKHKKKHKKKKOHzJHvmsrussvvEyEv...",
"......bgigjjjsjujsjsjsjsmsgrjujsyywnwKHKOKIJKIJKIHyvussissusuyHyE...",
".....bbicijgiiswuvjsjuvjvsjirjqjuHovKHyHKKKHKHKOyHyvsgrsisvuvsEHye..",
".....bjbijjrgigsyvvjuvsjrjsigsjisovpKvvxyKKHKKKOKJvvvrsrsrsvsvuHHe..",
".....bihjijgisjjxvuvvysjsjvsvvugjvwHyvvwxHHKIKOKKHvsxtsissvvuvExHj..",
".....bjejjjjgisvyvvwvvsjxssyvjjrnyyKyvxwHKHyJKKOyvrssuvusuuwuEvvHj..",
".....bjjjjsjrjjvvvvxvvuwvvvvuvwivHyHKHvyJKKyHHIHvsjrrsvsssuvEyvDKn..",
".....bjjnjmjjsjujvvvjvvyHyvmsHxjKHyvwxvyKIKHvKHyxtuvsjvrusvsvGvvHj..",
"....bbbjjvtjijsjvvnsvvyHyGwxwvvjHyvyHvnvKHyHvKKOvutvvHsssusuuvEvHv..",
".....bgjjnvvjsjsxyFxyHKHHyHyHyuvvzHnnjvmHHyIxPQKvvvvGvHrssrsvEyEHn..",
".....bbjjmwvjjugvyywHHKyHyHyHywvnvkukmskyKOOKRPKEvEutvHjrrssvuHyHj..",
".....bgjjjuyvjjisvvyHyyHHIyHyHJvnnvjjsmuHHKRORQHyHvvuyJFsrsrusHHHe..",
".....bbijkjvxkrgivyvyHKHBHJywHyvkvjjjsntxIKQPQLKHHvyvsHKysrsutvJId..",
".....bbjjmkvyvmjgsvvHyHIuvHHyHyvnkrvvuvvvKHKRKPOKvHvutuvuFrsruEHH...",
"......bgjjvnvyFvvjivHyyHKHzKHHyvvjjujwHyvOyKOKKJHvvvEvrssxvrsvGIx...",
".....bdjijjvvyyyyvvsjvHyHzJHKHyyHysvvJIyxHKEKKHHwGvvxvvusEvsusHHn...",
"......bhdjjvxvyHHyHyHyvyHHKKIKHwvHHvyHJHHvKyvEKHHyutuEvvsuHrsuHHj...",
"......gehijjwxwxwHyHyHJHyKHKKKyvuyyvKHyHzxHKvuvyxvHvvutusvEvsEyH....",
"......bijijjsvywxyHyHyIJIJKKOKEvjHxvKHyHKHyIOwutvIHvEHvutuEuuuHy....",
"......bcjhjjmjvyHvyvHyHzHKIKKKKKKHtuvHHzGIyvKOKvGHyvyvuvEvvssEHe....",
"......bbjijnjsjuwyHyyHyJIJIJIHKHIHxHywJHwHKHHMPKHyvvEvvvuHsuuHH.....",
".......bdjjsnvjjvyyHvyHyyHyHHHKIJyyHHyIyyKKKHOKOIJHvyvvHsHsuEHj.....",
".......bhjjnvvvvjGyyvyvvHvHKyKHyKHHyKHJHHHOKHKKOKPKHEvEyEvusEya.....",
"........bijvvvyvvwHyHvsuwyyHHKHKHKIKIJIHKKKOKKKIMKHHyHHvHuDvHm......",
"........bcjjvnvyvyyHwjxHyHHKIJzHKHJIJIJKIJKKOKIJIOKIHHyHGtvGw.......",
"........bbiknvvwxwyHyHHIJIKJIJKOKKKKKIKKHKKOKHHKKKOHxvHHuvEye.......",
".........bbjvnvvyyHyHyJzJIJIKKOKOKOKKJKIKKIJIKKOHvHxtEKvuEyv........",
"..........gejsnvyvHyHyHHKyyHKKOKKOKOKNKOJIJIHHKKFusuyJFvvEy.........",
"..........bgjmvwxwyHyHyKIJIKOKKOKKOKKKOKKKHKJKKOKHHIKHvDyHb.........",
"...........bejnvwxHyHHKHKKJKKOKKOKOKOKOKOKHHIHKIJIKHHyEyHe..........",
"............gjkvvyvyHyIJIJIOKKNKKOKOKOKKKHHvJKIJIJHHHHHHj...........",
"............bbjnvvyyHyHIJIKHKJKOKKKKKKOKIJvyIKHKHIKKKHyj............",
".............bjjvnvwHyHAHKHKIKIJKOKOKOKKHHvvKHKHHKHHyHe.............",
"..............bjjvvvxyHHyIJIJKJOIKKKOKIJIyHHHKIJIyHyEe..............",
"...............bjjnjywyHyHIJIHKIJKNKKIJIJHHyvHJIxEvu#...............",
"................bjjvvvyyHyHyKHKJIKJIJKHKHyHvHvHHyEf.................",
"..................hjnvvwxHyHHKHIJIJIKHKHIHyvHvHyv...................",
"...................bjvvvwvyHyyHyIHKHHKHIHyGHyHvd....................",
"....................bcjvvvywHwHyHyHKHHHyGyFvnb......................",
".......................djkvvvxwGyHvywxvvvnd.........................",
".........................bdejkvnvvukmjed............................",
"....................................................................",
"....................................................................",
"...................................................................."
};

/* XPM */
static const char *jupiter[] = {
/* width height num_colors chars_per_pixel */
"    72    72       50            1",
/* colors */
". c None",
"# c #330000",
"a c #003300",
"b c #333300",
"c c #000033",
"d c #330033",
"e c #003333",
"f c #333333",
"g c #663333",
"h c #336633",
"i c #666633",
"j c #996633",
"k c #cc6633",
"l c #669933",
"m c #999933",
"n c #cc9933",
"o c #003366",
"p c #333366",
"q c #663366",
"r c #336666",
"s c #666666",
"t c #996666",
"u c #cc6666",
"v c #669966",
"w c #999966",
"x c #cc9966",
"y c #99cc66",
"z c #cccc66",
"A c #ffcc66",
"B c #666699",
"C c #996699",
"D c #669999",
"E c #999999",
"F c #cc9999",
"G c #99cc99",
"H c #cccc99",
"I c #ffcc99",
"J c #ccff99",
"K c #ffff99",
"L c #9999cc",
"M c #cc99cc",
"N c #99cccc",
"O c #cccccc",
"P c #ffcccc",
"Q c #ccffcc",
"R c #ffffcc",
"S c #ccccff",
"T c #ffccff",
"U c #ccffff",
"V c #ffffff",
/* pixels */
"........................................................................",
"........................................................................",
"............................e#ebcf.e#a..................................",
"........................affffffffffffeffeda.............................",
".....................ebfffrrrfrirfhffffffefede..........................",
"...................fffffffsqssirsshsphpfffffefcf........................",
"..................fprshqhghssvssssshsfhphfpffffefec.....................",
"................bffissssisissvsssssssssiphfhpfffeffca...................",
"...............fffffvBvBssisswCvwsvssshshsphfpffpefpcf..................",
".............ffffbfisEEwEvsisswEDwtvwssssshqhfrffpfefoc.................",
"............ffhffgfgiswEEtssjsvEEEvEwEvssssrsrfrfhpfpefc................",
"...........frfssihgigiEEEEwwssiwEEEwBwEwssissirqhpfffpefc...............",
"..........ffsssisgigisjEOEEEwwtswEEEwEwDwssshsriphrphfpfob..............",
".........frrisssssisgiswEOOHEwwtwwEGEEwwEvvssssrriphpfpepec.............",
"........cfsssvsEwwtijijtwHMNFMwwtwEFGEEwEEwsvssisrsfrhphfpfe............",
"........fhssvCwEwEwwtititwHOOGFEwwvEHEGEwEEEvsssrirsfrfpfpepc...........",
".......ffhsBwDEEExGxwtjsjtwFOOHExwtEEGMGEwGwEwvsssrhsphrfrffec..........",
"......afsfswDEFGFGEExvtjwjtwHOOOGFwwEHGFHGFEwEvssvsshsphpfppffe.........",
"......ffssisEEGFGFHEwEwtjwjtwFOOOFGxwEHNOGFGEGwwvssssirqhrfhofod........",
"......firssswEMGMGFHHFwwwtwjwwHOOOGFwEEHHOGHEHEEvtvssshsphpfpfeec.......",
".....ffgiswstwGOFGOFHHHFwtmwtwuHOQOHHxwEGOOGHEyEEwsvsssrirfrfpffc.......",
"....effhsswwvtEHNMHOEOFHxwxwumwxHOOOEHwwEHOOHHFGEwEsvssvsrgrfrfefc......",
"....frgfiitwEwsHMOOHNEHHHHFwwttwxHPQOHHwwEHONHGFHEwvtvssirrfrfpffe......",
"....pssipitwEwwwGOOOHOEOHIHxwxwjwxHVOHHHxEGHOOHGHEGEwvssssirqhfpefc.....",
"...ffsvssiswwEEwEHOOOHOHOIJFwHxxtwxORSOHHxEHHOOHHGFyEwvsssrirpfffef.....",
"...efsBwssjwtxEFwxOOROOOHOIHHHnxwkwHPRVOHHxwGHOOHHEHEwBwsvsrgrhpffc.....",
"...ffsvDEwsiwwzEHExHOROPOOQIHHFxxwxtxHVORHHFwFHOOHHEGEwvsssshsfpfffe....",
"...ffrsEEwssiwxHFHGFHOROQOOKPHHxwxmxwxRRSRHzwEGHOOOHHwEEwvssshphffef....",
"...fhgssEEEwttwxHHxGHOPRQRPQRIKHwxtwxwxPRSIHHxwHHONHHHEyEwvsshsfrffc....",
"..effrisEEGEEwwwxHFHxHQSVROVRPQAFwxxjxwxRVUIHHxwGHOOGFGEEwvssshqfffef...",
"..#fhgrsvEFOGFwtxFHHHFHHVVOQVRPOKHHxxwnxHRVVOIHxEFHOHNHwEEwwssshrfffe...",
"..effrisitGLOEEwwwHHHHxOQVVOVQRRIHIRxxtxxHPRVOHHxwGHNHFGFwEDvssiphpf....",
"...fhgssssEwOOHEwwxFGHHzORVVOVORPRRRHxmxwxzPVQPHHxwFHNOGGEwwEssirghff...",
"..fffrgvwsswGOOHEwwxHHHHFHVUVRROQOIOIzxtntxHPVUPHHxwEHHMGHEwvwssshpfec..",
"...fffssvsswEFOOHEwEzIHOIzORVVVORORKHIxxwxwxwPQVOHHwwEGHLGEEwBvsshiffa..",
"..effhfssiswtGESOOGwxHHIHHzPVVVVOROORHHxxjxjxzOVOPHHxEwGHEGEwwsvssphfc..",
"...fffipisswEwEOOOHEwxHHKPHzHVUVVOQOIQIzFwntwuwIUOOHzxEEGFGEEEvtsrifff..",
"...ffhfsissswwEHOOQHFExzHIOIHPVVVVPRORPHzxwxjxjxORSRHExwEGELEwDsvsgrfa..",
"...fffifsiswstwwEOOUHHGFzIJPzHHVVVVRVRROHFxwtmwtxHROOHwwwEwEEEwtssshfd..",
"...feffssssiwwEEwGOVOPwHxHHIRHHIVUVVRVRPQHwxwjumwwHSOOHEwwEwEEDEvsipfe..",
"...ffffhsisssswEwEHOROHwHwxHIQIHRRVVVVRROHIGuwjtxjxHOOOHEwtEvEEvssshff..",
"...efffrgriswvtvEwwHSQPHOHHHHIRHzPUVVRTVRORHzwwjtwjtHOOOEEwwEwDCEsshff..",
"....fffhrissssvtwEwEHOVQPHFzHHIRHHPVVURVRRPRHxwumtjtwHOOOEwwswswsvssfe..",
"....feffgrisiwswvwFwwHORVQHFzFHIOIHKVVOVRSRROHEwjtwjitwEOHEEwtvsvBsrf...",
"....effhpipsssvtvFGHEEHORPRHFzHIJIHHROUOVROQPOHxwwjtwjtwFNMEwtssssshp...",
"....#fffhpihsisvwwEwEyFHQSROHHHzIHIHHPRVROOROKOHFxwjsjiitwEGEwvtsirgfc..",
".....effrfrirsswsEvtEEwHHORUPHHFHHHHHHHRVURORORHHwwtjttiiittEEsssiphf...",
".....feffifrgsiswvEwwEHEHHORVHHHHORHIHHOPQTRPROOOHHwtljsgigjEwEssihfc...",
"......fffrfirirsvCwEwwwEwFHOVQPOHHOOPHzHHPQOQOQIOHHwwtijsigiEwsEsrff....",
"......efffhpirssiswvEtGOHGxHORUIHHOHKPHHzHOROROOHOHFEwtijiigswDssiff....",
".......fefrfrissssvtvwwOHOwEHORSOIHHHHHHFHHROOQPQHOGFwwtiqiigstvsrff....",
".......efffhfshsisvsEswEGOwHHxOQROOIHHHIHHxGOOOOOHEHEFwwsjgigisssff.....",
"........feffrfirssssvtvtwEFHHGFOUROHHFHHzFGxEHOOOOOFGFEssisghgffgrf.....",
".........ffffhpirisvsvsvtvwGHFyFOOQOOHHxGFHxyFGOOOHOGEEwwsiggfgbff......",
".........effhphfssisstvtvwtwEwEwGHOOOOOHHHEHwwEHOOOHMGEEwssihghfb.......",
"..........efffhfhrshsisvtEvtvEwExEHOzxzFOHHEwFwwFGMGEHEEwssiffff........",
"..........cfefphffisisssvwvwsEHGwxGHwwwwzEOFyEwwwEEHEEEEwEssiffb........",
"...........affffrfrfsrissstvtwEEHwwEwxwxExyFHxEwwwwEEGEEwsvsrff.........",
"............cefffhfhpishsvssvswwEswEwwxwwwxHLxwFEwswEEEDwBssiff.........",
".............beffphfirhsisisisssiwEwwtwtnwxwHEwxEwwsvEEsEsshpf..........",
"..............cefffrffsfrfsssisivswwswwwtwwFEwwwwEswsssEsssff...........",
"................fefffhfhgrhhshssissswstvwwwwGEwwEwtvsisssrhf............",
".................efefffphffsfshipisisvstwEEEEEwttvtssihfhpf.............",
"..................cfeffffrffhqhqssisssvsswtEEEEsitvisrgffb..............",
"....................fefeffhffhqhhsrgisssvsvswDwBvigsifff................",
"......................feffffphffrghfhfsssssssssvssfhffe.................",
"........................e#effffhfffrfifissisissssphf#...................",
"..........................fafefffffffprfrirfrffffff.....................",
"..............................fcfffffffhfffffffe........................",
".................................acae#ededada...........................",
"........................................................................",
"........................................................................"
};

/* XPM */
static const char *mars[] = {
/* width height num_colors chars_per_pixel */
"    72    72       39            1",
/* colors */
". c None",
"# c #330000",
"a c #003300",
"b c #333300",
"c c #663300",
"d c #336600",
"e c #000033",
"f c #330033",
"g c #003333",
"h c #333333",
"i c #663333",
"j c #336633",
"k c #666633",
"l c #996633",
"m c #cc6633",
"n c #669933",
"o c #999933",
"p c #cc9933",
"q c #333366",
"r c #663366",
"s c #336666",
"t c #666666",
"u c #996666",
"v c #cc6666",
"w c #669966",
"x c #999966",
"y c #cc9966",
"z c #ff9966",
"A c #99cc66",
"B c #cccc66",
"C c #ffcc66",
"D c #996699",
"E c #669999",
"F c #999999",
"G c #cc9999",
"H c #ff9999",
"I c #99cc99",
"J c #cccc99",
"K c #ffcc99",
/* pixels */
"............................bhluoyyByByyxlkh............................",
".........................ilxyyByJyKyKzBCzJzCyyk#........................",
"......................hlyAyJyJyKBCJCJCKJzByBKBKyxk......................",
"....................ixyxyGByJzJBHJzJzJzJBGBHBHxxxyxi....................",
"..................hxoxyyBJzJyBKCJCJCJCJzGByJyByzyxyxxk..................",
"................buouyyyyJyJCJzJyKGCGCGBJyyJyBGyJxGyGxuyh................",
"...............ixuxyyyxJyKyyJyKyBJyKByyyByyyyxyxyyByJyxxk...............",
"..............uxxyxyyJyBGBBHBzJBHCJCGBGBGyyxxyxxxxyxyyxuxy#.............",
"............buxyxyxyByJyCGCyJBHBJzJCyyyyyBxyxuyxvxxyxyKxuxyh............",
"...........huxxyxyyJGBGCJyJyJyJzJBHBGByyJxyFyxxxxyuxyyJyxyBGk...........",
"..........hkxyxyxGJyJCGyyByJzJCyBzKByyyxyGyxxvxyuxyxyxyCGyBKyk..........",
".........hlxxxyFJyJyJyBJyJyJBHBJHBKyKyBGByxyxyxyxyxxyxyyBJyyJGk.........",
"........btxxvxGBHJyJyJHBKBHBHBKBKBHByJyyJBGyyFyGxyxyxyGByyKBzBJi........",
"........uxFuxyJGBGBGBGCJKGCJKJKKKCJBzBGBKyJyJyyxGyxyxyyxGyBHBGBGh.......",
".......tFxyxxGyJGBGKJCJGBKJCJCKCKJCGJCBKBKyJyJyJyJyGxyxyxyyByJzBG.......",
"......ixxuxuyyFyJGJCJGBGBGCGKyKJCKGCBGKyKyKBKyJyJyJyyxyxyyJKyBGBJx......",
".....bExxukxxGBGBJKJJGJyJKyJBJyKJzBGCBKCJCBHBJyJyJyJyGxyxyBCGByyyKi.....",
".....txDxkuyyFyIGBJKyJyJyJyJyyJyBGByJyyKyKCJCGByGyJxyByyxyGBKyJyyyI#....",
"....hxuxuxxyFBGyJHJJGJJKJyJyBGyByyyyyByBHBHBHByxyxyJyxyxyyyKyByyGxyt....",
"....uFxFxxGxGyJyJJCJKCJKyJzJyByyJyJByGCyByKBKyyyyByyGyxyyxByJyByByyB#...",
"...hxxFuxGxGBGxJyJGKJJKGByJyJyJyyyJyByGBHBJzBKyByGxByByFyyyByyGyyByxu...",
"...ttxxFxyFBGBGBGJKBKGCGBGByyGyJyyBGKBGCJzJCGBKyJyyyxGyyxyyyGBxyyyyyB...",
"..htxFuxFyGyJyJyyJyJGJyJyJGyJxyJyJyKyJyJyJyKBHBKyByByyBxyxyxyyyxxyJyGk..",
"..kuwuFxyFyJFyJyJyJyKyJyGyBxyxGyBGBGByJyByKyJBHBKyGyyxyyxyyyxxyJyyxyyx..",
"..tFuxFxFyJGyIyxGByJyyyByxGxGxyxGyyyGByGyBGBHBBGCJyByyxyyxBxyyGyJyyxByh.",
".hwuwuxGxFyFyxGyxyGyxJxGxGxyyxxxxGAGxxyyJyByBGBKyByyFByGBxyxxyBxyyByyGk.",
".itxDxxxGxGxyyxyGxyJyxyxyxyJxGxxGyxyxtttxGBGyByyKJyByyxyyyyxvxuxJyyxyyx.",
".twixuFxxGJyJGxyxGxyxyFxyGxyyyJHBJJyxtxxyCGByyJyBHBGyyxyyByxxytxyyByxJx#",
".tuktxxGGxyFyBGxyxyxyxyxxyxyxJyBGyyGxuxyGxyyByCJzBGByxyyyGyyxyxuxyyyyyyh",
"httkFuxxGxGxyFByxyFyxyxyxyxyyyyGByBGxxxuyBByGCyyJyByyyxyBxyByxuxxyxxyBxi",
"hkttuxFxGxxyxyxGxyxyxxyuxxyxxyyxyyxyxuyxxyGyBGyyyBGyBxyyuttyyywuxxyuyGxt",
"htktxuxxFyFxGxyxxxxuyuxyxyyyyyxByxyxuxltuxyxyxBByyByyyyxktkxyGtutyxxyxxl",
"htttxxDxxxyxxyxyuyxltkuxyoyxoyyyxxuoxxyxlxuxyyyyyyyyyyxktkuxyxxuwuxuyxxt",
"htkutxxFxDxyxxvxxuoxuxxuxuxvxyxyxyxuluxuxtyxxyyxyyyxyyxutxxyxxuxtxuxxyul",
"hktttxuxxyFxGuxxukuuoulxkukxlxlxmxlxxukulxltlxyCyBxyyoyxlxuxyuxultxxyuwu",
"hhttuwuxDxxyxuxyltxxxxuxtktktltxtkttkuotuktktxyByyyyyyyyxuyxxlxxuxuxuxlt",
"hitttuxxxFxDxxxltkuxlxulultkuutoutltktuktoxyulyyxyxxpxyyxououxuktktuxunu",
"bhktktutuxxyxuxtkuouxuxunuuxlxoyxytktlxluxulxxuxyypyxyyyyuwuxlxtttkttltk",
"ghitttxtxuxuxutluktltounuxkuxluxuoxluwuwukutltoupxyxyyoyyxlxuxuktkttktku",
"#hjktktltxuxxuwuktkultluukxltxlxyxuukxluoxxuwltkxxpyoyyyxxuouxkutukttkti",
".hhrktktuxuxuxtltltotxlwlukuouxlxyoxuyxltuoukutuluuoyxyxyouxulxtlttkukkh",
".hijrkttutxtxutxlwlukutltoutlxlxlxuououtlttuxkukxtltkulxlxulxtkutktktkth",
".hhkjrktltuwuwukuukukxltukuotluxuouxxuoutkukutnukxuxkuktluounutktkktitlh",
".hhhthtktwltuukxtlwltuwltxkulwulxuoulxuxlxtxkktkukukukuktktkuktkktitktk.",
".bhistittkttkxtltltukukxtltxkulwlulxukxlwuouttkutlxuouwlttktitktithktlt.",
"..hhktkhutltltutotlwlxtlutltunuukwukxulxuxuoultlxuouxkutltktjitikktitkh.",
"..hhhtrktkttkunukukukukuwlwluukukukukxtuououxuouxlxluotltltkrktksijtikf.",
"..ghihksktkuktltkukukutltukuntlwluxkulxkuxulxlxuouououlwktltkrktitijtk..",
"...hhhhikitkltkuktltnuktltltukukunulwkulxkxuwuouououotltluktkktkthtikh..",
"....hhhkhtktkkukuktltkukwltkuktltuktltltultllxltoulwluktkoukrjitkijth#..",
"....bhhhhkikrkkktltkuktlktltkuktlkukukunukxkukxluoultktkultkkrkrjtiih...",
".....hbhhhkhkktkktlktlktltkukkukktktktltkuktltlxkukxltlkukltikskrkjig...",
".....ehhhijitikrlktkktltktkktkktktlkukkukkltltltlxltklulkukkthkrjiqj....",
"......bhhhhhkhkkitktlktktkitkrkitkitkktkktkltlkltkkuktkxkktkhtkhkhkf....",
".......hhhhhijitikikitkikrkikiskiktkkukltktkktltlktkkktktlijihkqihh.....",
"........hbhhhihkhkrkkhtihkhkqjihjihtikrkiklrkktkkukkrkkikthrjrhkhhb.....",
".........hfbhhijijhisihjrhjhihkhrjikkrkktitkklkkkikiktitkijihjhhhh......",
".........hahhbjihisihjihkhijhihkhijhijijikkitititkrkijikijhhkhihh.......",
"..........fbhhhijijijijrhkhihjihkhijrjiqkqkkikikijijrkhkhihrhhhh........",
"..........aebhbhihijihijhhhhihjihjihihjihkhrjijqkhkqkhkhhhhjhhhb........",
"...........#gfhbhdihijhihkhkhhihhihjhihjihkhkhkhijihihhihjhhhia.........",
"............bgbhhhhhhihjihhhihjijhihkhkhijihijrkkqkhjihjhihhhb..........",
".............fafbhbhhchhhihhjhhhihjihihkqijijikhihhihhhhhhhhh...........",
"...............hhbhhhhhhihjihihhhkhthjihkhkhkhkhhkhhjhhqhhh#............",
".................h#hbhbhhbhhhhhkhhhihijikihkhhhhhhhhihhhhh..............",
"..................g#hbhhhhhbhhhhhihhkhijihhhhhihhhihhhhhb...............",
"....................hebfbhbhhbhhbhhibhkhhhihhhhhhhhhhha.................",
"......................hah#hbhhhbhihjihhbhbhhhbhhhbha....................",
".........................hafhbhhhhbhhbhhhhhbhhhbhe......................",
"..........................faebebfbhh.hh#gbhebh.ea.......................",
".............................ebeafafgbebf...............................",
"..................................ea...ea..............................."
};

/* XPM */
static const char *mercury[] = {
/* width height num_colors chars_per_pixel */
"    46    72        6            1",
/* colors */
". c None",
"# c #333333",
"a c #666666",
"b c #999999",
"c c #cccccc",
"d c #ffffff",
/* pixels */
"..............................#.###a##########",
"............................##aaaa####a#a#####",
".........................##aaaa#a#a###########",
"........................aabaaa#a##############",
".....................#aabaaaa##a##a####a######",
"................#...abbbbbbaa#a#aa###a########",
"..................#bcabbabaaaaaa###a##########",
".................acbbbabbabaaa#aa####a#a######",
"...............#bcbbbbabababaaa##a#########.##",
"..............#bcbbbbababaaaa##a####a#########",
".............#bcbcbbbbaabaaaaa##a#a####a######",
"............#cbcbbbbaaaaabaa#aa#############.#",
"............cbcbcbbbababaaaa#a#a##############",
"...........bcbcbcbbaaaabaaaa#a################",
"..........bcccbcbbbbabaaaa#aa#a#############.#",
".........#ccbbabcbbabbaaaaaa##################",
"........#cdcbcbbbbbbabbaaaa################.##",
"........bdccbcabbbbbaaaaaa#a#a################",
".......#dcccbbbbbbbabaaaaaa####a###########.##",
".......ccccccbcbbbbaaaaaa##a#################.",
"......#cccccbcbcbbbaaaaa#aa#a#a###########.###",
"......ccccbccbcbbabaaaa#a#aa#a###a############",
".....#cccccbccbbbbaaaaa#aaa#a##a#########.##.#",
".....bcbccbccbbbbba#aaa#aa#a#a###a####.#######",
".....cbcbccbbbabbbaaaa#aa#a#a###########.##.##",
"....#cbbcbbbbbbbbaaaaaa#a#a###a##a###########.",
"....accbcbbbcbaabaaaa#a#a##a###a########.##.##",
"....bccbccbcbbbbaaaaaaa#aa##a#################",
"....cccccbcbcabaabbabaa#aa#a##a##a#######.###.",
"...#dccccbcbbbcbbbbbaaaa#a#########a#######.##",
"...acccccbbbbbbbabacaaaa#a#a#########a########",
"...acccbccbcbbbbbabbaaa#a#a###a###########.###",
"...bccccbcbcbcbabbbaaaa#a#a#a######a########.#",
"...bcccbbbcbcbbbaababaa#a#a##############.####",
"...bcccbccbbcbcabaaaaaa##a###################.",
"...ccccbbcbbbbbabbabaa#a####a#########.###.###",
"...bccbbbbbbbbbabaaaaa########################",
"...bccccbcbbbbaa#aa##a#a#############.##.###.#",
"...bbcccbbbbbbaaaaa##a########################",
"...accbcbcbbcabaaaa#a####################.####",
"...abcccbbcbbabaaa###a#a#a###########.######.#",
"...#cccbcbbbbbaaaaaa#a#a######################",
"....ccccbcbbbbbaaaa###a#aa#######a######.#####",
"....cccbcccbbcaaaaaa##a###a##########.####.##.",
"....acbccbbbccbababaaaa#a#####################",
"....#cbccbcbcbbbabbaaa#a###a####a######.####.#",
".....cbccbbbbbbbabbaaaa#aa##a####a############",
".....acbcbcbbabababbaaaaaa#a##a###############",
".....#cbccbabbbbbabaaaab#aa##a###########.####",
"......bcbccbcabababbaba#aaa#a###a#a###########",
"......#cccccbbbbbbabaaa#a#aaaa#a#a##a#########",
".......bccccbbcbbbbbaaaa#a#a#a##a##a#a########",
".......#dccccbbcbbbaaaa#aa#aa#a##a##a#a#######",
"........bccccbbbbbbcbaa#a#a#aaa#a##a#a#a#####.",
"........#dbcbdbbbbbbaaaa#aaa#a#a####a#########",
".........adbcbbbbcacbaaaaaa#aa##a#a##a#a######",
"..........ccbcbbbbbbbbaaa#aa#a#a###a#a##a#####",
"...........cccccbcabbcbbabab#a##a####a#a#a####",
"...........#dcccbbbbbbaabaaaaa#####a##a##a####",
"............accccbbbabbbaaaaaaa#a#######a#####",
".............bccbcbbbbbaaaaa#aa#a######a#a####",
"..............acbcbbbbbcabaaaa#aaa#a#a##a####.",
"...............acbcbcbbbbaaaaaaaaa#a#a#a#a####",
"................#ccbcbbbabbaaaaaa#a#a#a#aa####",
"..................bccbbbbbbbaaaaaa#a#aaa#a####",
"...................acccbbbbbbaaa#aa#a#######.#",
".....................bccbbbbbbaaaa#a#aa#######",
"......................#bcbcbbbaaaaaaa#a#######",
"........................#acbbbbaaaaaaa#a######",
"..........................#abbbbaaaaa#a#######",
"..............................aabbbaaaaa##a###",
".................................##aaa#####a##"
};

/* XPM */
static const char *moon[] = {
/* width height num_colors chars_per_pixel */
"    66    66       33            1",
/* colors */
". c None",
"# c #330000",
"a c #003300",
"b c #333300",
"c c #000033",
"d c #330033",
"e c #003333",
"f c #333333",
"g c #663333",
"h c #993333",
"i c #336633",
"j c #666633",
"k c #996633",
"l c #663366",
"m c #993366",
"n c #336666",
"o c #666666",
"p c #996666",
"q c #669966",
"r c #999966",
"s c #666699",
"t c #996699",
"u c #669999",
"v c #999999",
"w c #cc9999",
"x c #99cc99",
"y c #cccc99",
"z c #0000cc",
"A c #cc00cc",
"B c #9999cc",
"C c #cc99cc",
"D c #99cccc",
"E c #cccccc",
/* pixels */
"..............................#.#..#..............................",
".......................bcbfffooooooffdada.........................",
"....................cbffopsvrtrvvvvwxvpof.da......................",
"....................foppopppvpuppvvwvyDwEvjda#....................",
"..................ffpootqpooropvrvvxvvwxwDwxod....................",
"................#fgoopoppupvptqtpopvvvvwvvyvwxlbc.................",
"...............dgooooporpovoroporopopvrvvvwBwvytfbc...............",
"..............fgooohoopotopptoootpovpvpvvwvvxvvxwo#c..............",
".............fgogopopopopooorvppvropvpvvyvxwvwxwvxof#.............",
".............gooopooopopqpoopovpqtorvvvvvvvvvvwvwvwvdb............",
"...........fggoopopopoopoopoppovpotrtrvvrvpvvwxExCvvrf#...........",
"...........giooppqopopopopoopupopvvvrtrtvvwvrvwxCxwxvv#f..........",
"..........fgoopvptoopoopoopoppvpqtrvvvvrvvrvvwvEvwvvvvpfd.........",
".........gfopoptqopopopopopopupvvvvpvvvvwvwvvvyvwxvwvwvobd........",
".........golpopqpprotrvoopvropvpvvvvrvwrvvvwyByvvwvxwvxwn#........",
"........flojpoooopsrpsrppovvvpvvvrvvwrvvvwvyByvEvvwvvvvvwfb.......",
"........gojoooppopotrpvpuvpvvvvrvvpvvvvwvyBzyEwxwxvwxwvvvrcb......",
".......glgoopotopoprsrvvpvrvvwvrtrvrvwvyvvyyDwzAxwvvvvvwvvjd......",
"......gljoopopopoovpvpsrvpvpvvwvvvtvpvvvvwvvwDyEvvwvyvvvwvvf......",
"......fooopopoporpvrsrvvvvvvvrvvrvpvvvwvvvyByvEvEwvvvwvwxwvo#.....",
".....fgojpopoopovvvvrvtrpvrtrvvvtrvrtvvvwxwvvwvyvxwvwxvvvvyv#e....",
"....gfoolrooppqtrvvvtrvtvrtvpvvrvtvvrvrvvvvwvvvwvwvxvvwyvyvvo#....",
"....fjljpopotqppvpvvvvpvvvvrvvwvrvrvtrvrvrvvvvvvvvwvwvvvwDwvrc....",
"....fgolopopvpsrtvrvvwrvvrvvpvvwvvvrvtrtvtvwxwrvvvvvvvvwvyBvwf....",
"...fgogopoopvpvortrvpvvvwvwEvvvvvrtvpvvrvrvvwvvppvrvrvwvvvyvxgf...",
"...fjloojopovortrsrtvvwvvvxwvvwrvvwrvpvpvpvrvvpqpvvpvvprvvwvwoc...",
"...fljoopopovpvortrvvvvvwvvvrvvvvrvvpvrvtrtvprtrtovvpvpsrvEvxv#...",
"...gooplopqtrtqptrvvrvvrvwvrvvrtvwvvrtvvpupvvpovrvrvvvvppvyCvwf...",
"..fgopqoppvvrptortvrvvwvvrvvwvvrvpvpvvpvvrvrtqptvvvpwvvrsrByxCf...",
"..foovpoopvpvortrvvtvwrvvvvvvvwvvvrvvvvvvrtvpvortrvvvvvprtxAyvff..",
"..fpovpopqtrtvpqtvrvvvvvrtrwrvvrvvvvrvrvvvvrtppupovpvwvrovwxCyo#..",
"..gopropotrsrvpvvvpvrvrtprtvvvrtvwvrtvvwrwvwvrspoportxvvpvvyEvof..",
"..fpovtqportrovvrtvrtrtrooopvvvrvrtvvrvvvwEvvrpqpopovvwvvvrvCxod..",
".ffotrvpvpvrtvpvrvpvvtrtppoprtrtrvvrtvpvvvvvpotoooopprvyvvtrwEob..",
".fogrvvtqtrvvvpvtrvpqpupqopupvvvtvrtrvpvprporoopjmooopvvwvrtDylb..",
".fgopvrvprvvvpupvovvtpoopopoprtrvrtvvpvrvtopopoooopopvvvvvpvyvo#..",
"..glqtvpovtrvvrvvpvrooogoooopvvvrtvrvvrtvropspoohoopopvvrvpvxCff..",
"..fopvrvpvvvvpvvvvpvpogogpopopvpvrvtprtrotopoojlojoopovvwvopvyf...",
"..goopvovpvvpvvwrtrtroljopopvvvrtvpvrsroprtojljloopoortrvpoorvd...",
"..fgvovpvovrvpvvpqtqtopoopvvrvpvvorvvpvotoroogooklpoppopvoootrd...",
"..goopvvrtrtrvvpvpovrtrptqtrvvvvvrvtrvppvvvpvpogoopovoooojmjvjc...",
"..floprtvpqtvvrvpvpvvrtqpvvvwvwvvvvrptovvrvvvvpooprpopopgoootf#...",
"..fjopurvpvrtrtrvoprtrotropvvvvwvppspoorvvwvvwvrpsvpooogoljmr.....",
"..dgoptrvvpvrtvvpvspoportovrvvvrvvrvopvvpvvrvvvvvpovpogojloogf....",
"...foortrtvovovrtrpooopoopvpvvwvvwrtrvvrvvvvwvwxwvproogoljopf.....",
"...ggopuvrpvprtvvruppooolojtrvvvrvvvvvvvppopovvwxvooljljolpo#.....",
"....fooppvsrtrvpvtrvpropojpovprvvwvrvvrpooooppvxwvvpoljlojvf#.....",
"....fopovpvpvortqvpvvBvvpopvpvpvvvwvpvpoljpojorCyvvroopjlpo#......",
"....bgopvrvvvpvrtvrvvwvrtoovvvvpvyvpooogooloppvvzvvtkopoopf.......",
".....fpvotrvpvtrvpvtrvvvrwvvrvrvwvvrlogookopopvEEyvpovpopf#.......",
".....fgovrtvvrovpvvrvvvwvvvvwvvwvvvoooogpoopovvwvvwvvpooof........",
"......gotvrvpvpvqvvpvwvrvwvyvyvvvvrtrpopoppopvvvvwxpvropf.........",
"......fgrvpvvvvpvovpvrvvwxwvEvwvyvvpvtropsrvvvvvrvyBvopfd.........",
".......fopvvrvvpvpvvvvwvExEvwxvvwvvvvvvvrvvvwvwvyByvpoo#..........",
".......#forvvvvvrvpvvvyvyvwDwvEvxwvyvvwvvvwvyxwvyvwvoo#c..........",
"........#lotvwvwDwvvvwvvCxvwvyvwByvvwvxwvwxvCxCxwvvro#a...........",
"..........orrvvyzzyvvvyvvwvvyvvvyvwvvvvwxwvwxwxvvvvo#c............",
".........f#fvvwvyvwvvwvvwvyvvvwvvvvvvwxwByvvEvwvpvgcb.............",
"...........ffpvvvEvyvvwxvvwvwvvvwvvwvvyvyvvwvvvvrf#...............",
"............fdoyvvyvvwvvvyvxvyvyvvvvwvwxvvwxvwvo#c................",
".............bcfrwBywxvwvvwvCxCvyvrvvvxwvwvvwof.#.................",
"...............d.fvyDCyvvyvxvvvwvvwvvrvwDwvof.#...................",
".................b.dovEyvvCvwvwxvyvwxwByoo.bc.....................",
"....................b.fovvxwvyvwDwEvvojc#.d.......................",
"......................#..#.fffofffb.d.#...........................",
".............................#...................................."
};

/* XPM */
static const char *neptune[] = {
/* width height num_colors chars_per_pixel */
"    72    72       33            1",
/* colors */
". c None",
"# c #003300",
"a c #000033",
"b c #330033",
"c c #003333",
"d c #333333",
"e c #003366",
"f c #333366",
"g c #006666",
"h c #336666",
"i c #006699",
"j c #336699",
"k c #666699",
"l c #339999",
"m c #669999",
"n c #3366cc",
"o c #6666cc",
"p c #3399cc",
"q c #6699cc",
"r c #9999cc",
"s c #66cccc",
"t c #99cccc",
"u c #cccccc",
"v c #3366ff",
"w c #6666ff",
"x c #9966ff",
"y c #3399ff",
"z c #6699ff",
"A c #9999ff",
"B c #66ccff",
"C c #99ccff",
"D c #ccccff",
"E c #ffffff",
/* pixels */
"........................................................................",
"..............................accfehefecc...............................",
"..........................cfjpoqpopoppqnnpjjec..........................",
".......................cjoqzqqqzoqzqoqnqqnqnpjjec.......................",
".....................fpoqzqqwqqozqpqzqqwpqnqnqnpjjc.....................",
"...................fqqzqzqqzqqzqqzoqoyoqqoqpopoponjic...................",
".................cqzqzqrqzrqzrzqzqzqzqqqvqpoqpopnpnknga.................",
"................jAqqzrAzrzrzrzqqqqqqqozqqqwqpoqnqqnpjnjc................",
"..............cqzqAqAqqqqqzoqqozozozopqopopqwpqqnqnqpnlnh...............",
".............fzrqAqqqzozoqqqyoqqqqpoqzqpwqqnqqnqnqpnopnjnga.............",
"............jqqzqqozoqqqzpwqqzqwpwqqpoqoqpozpopopopopopjpjjc............",
"...........jqzqozqqqqzqnqqqzoqqqqqqwqzpzqwpqopqznqnqnpopnjji............",
"..........jqqozqqwqzoqzqzqwqqzqzqwqqqqoqqqqopzopqnqpopjqnpjnha..........",
".........hzqzqqqqqqqzqqzoqqzqqwqqqzqwqzqwpzqqopoqqnqnqnpjnpjjg..........",
"........fqoqqwqzozqwqzqqzrzqzqqzqzqqqzqqqqozqqzqnzqnqnqnqnjpnje.........",
".......aqzqzqqqqzqzqqqzrzqqAqrzrqzqzqqwqzqzqoznqqnqqnqnpnqnjjnjc........",
".......qqqqozqzoqqqAqzrzqAqqAzrAArzrzqqzqqozqqqzqqnqpopopjpnpjjg........",
"......fqzozqqzrzrzqzrqzrqzrArCrCrArzrzrzrzqqzqqozozqopqpopolnjjje.......",
".....aqzqqqzrqzqzrzrzrzqAqzqAqCrztzrzrzqzrzqqwqzqqqnzqopopnnlnpji.......",
".....jqqzqzqzqAqrzrzqAqAqArzrzrzqAqAqzrqAqqAqqzqqzqqqnqqnqpopjnjje......",
"....czqzqrzrqAqzqAqrzqAqAqzrzrzrzqAqrzqAqzrzqAqqwqqwqznqqnqnnpjjji#.....",
"....kqzrqzqzrzqrzqAqAqrzqAqAszrzrzrBqAqqAqzqqzqAqqzqqqqvqnqnqjpnjjc.....",
"...aqzqqAqAqqAqAqAqzrzrzrqCqAqAqCqAqAqAqzrqAqrzqqzoqzoqqqnqpnpjnlij.....",
"...hzrzqzrqAqzrzrzrzrzrBrzrzrzrzrzrzrzrBrzrzqzqzoqzqqzqnzqnqnopjnjga....",
"...qqzrqAqzqAqzrzqAqCqAqAqAqAtzrBrztzrzrzrzqAqrzrzqqoqzqnqqnqnlnjjje....",
"..czqqzqqAqAqAqAqAsArztAqCrCqArzrArzrCqAqAqAqzqqzqqzqzoqqnqnqnpnlnjg....",
"..jqAqAqAqzqAqrzrArzrAqArzrzrztztCCuzrzrBrzrqArzrzqqwqqqwqpqnqnpjjjid...",
"..oqqzrzqAqrzrztAsAtztAsArBrzqzrzrqAqAtAqAqCqzrqzrzqqqznqpopopnkpnjgc...",
"..qzrzqqAqAqAqAqAqArAqAqzrzqAqqzrzqzqqzqAqAqAqzrzqqAqwqqqwqnqnqnjnjje...",
".czqzrzrzrzrztArBAtztzrzrzqAtAqqqqzqqzqqqzqrzrzrqAqqzqqzopqqnqnpnljih...",
".fzrqzrzrzrzrzrzrAqAArzrzqrzDDqzozqoqqwqqqzqzrzsAqzrqzqqqqwpqnpjpjnjga..",
".jqzrqzrzqAsArBrztAqCrCqCrzqqADtzqqzqzqqzrzrqzrzrzrzqqwqzoqnqnqnnjjij...",
".jAqzrzqrzrzrzrAqAqCrACrACrDCrCDuAqqwqqwqqzqAqqAqAqzrzqqqqpqnqnpjpjjga..",
".oqqzqrzrzrBrAsArBrAAsACrCAtDEEDDCArAqArzrzrqAqzqqAqzrzqwqwqpopnpjnihc..",
".pqAqAqAqCqAqAqABrAtzrArzrCArzrCtDtDtAqAqAqAqAqArzqrqzqqqqpoqnqnjnjjia..",
".qqzrzrzrzrzrCqArzrzrCqAtzrzrzrqzqzqzqAqzrzrztAtzrzqzqqzqwqqnqnpnljjhc..",
".ozqqAqAqAqCqArztAqCAqAtzrAsAqzrzrqAqqzrqAqBrzqArBrzqqwqqqzopqnqjnjija..",
".qqAqzrztzrAqAsAqAAqAtzrAqAqAqAqqzqqzrqzqzrqAqAqzrzqqzqqwqqqopnnpjjjgc..",
".pqzrqzrzrztzrAqAsArBrAqCAqCrzrzrzrzozqAqrzqAqqzqqqzrqzqqopznqpojpjij...",
".oqqzrzrztzrzrztzrzrAqArzrAqAqBrqzqqzrqzrzqAqzrzrzrqwqqozqopqopnlnjjga..",
".jqzrzrzrzrzrzrzrAtzrCqCrBrztAqzrqAqqzrqzqAqqAqqzqzqqzqqopzopoponjije...",
".jqqzrzrzrzrBrAsAqAqAqAqArzrzrzrzqzrzqzqAqqAqzrzrqzqzoqzqopqnpnpjpjih.a.",
".eqAqzrzqCqAqAqArztAqCrABrAsAqAqAqqzqrzqqzqzrqzqzqqqqzqopzopopolnjjhe..#",
".cqwqrzrqAqAqCqAsAqArzqAqAqAqAqCqzrqzqqAqrzrzqAqrzqwqqozqnqpopnnlnijc..a",
".aqqzqrzqAqtzrzrzrzqAqCqAqAqAqzrqzqAqzoqzqzqrzqzqqAqqzqqnqqnpolnjjjea.#.",
"c.jqrzqAqCqAqAqAqAqAqAqAqzrzqrzqAqqzqqAqzrqzqqAqzqqzoqopzopopnnlnjih..a.",
"..fqzqAqAqAqAqAqzrzqzqAqqAqqzqrzqqzqozqqqzqrzqqqrwqqqzqopqnqnpjnjjge.c.c",
"...qzqqAqzrzqAqrzqrzrqqzqqzrqzqqzqqAqqzozqwqqwqzqqzqoqyqopopojpjjiha....",
"...jqAqzrqAqAqzqqAqqzqzrzqqzqzqzqzoqzqqqqqqzqqzoqzoqzqoqpopnpnjpjje.....",
"...eqzrqACrzqqrzqzqzqrzqqzqqAqqqqqzqqozqwqzoqzqqzqqqnqpwqnqnqjnjihe.....",
"....oqzqAqzqAqzqqqzqqzqqzrzqqzqxqzqozqqzqqqzqoqqoqwqqwqpopnqjpjjjg......",
"....fqqzqrzqqzqqAqqAqqzrqqozqozqqozqqzoqqwqqqzozqpqnqpopopopnjnijc......",
".....qqzrzqqzqqzqzqqzqqwqzqqzqqqzqqqwqqzqqozoqqpozoqyopopnpjnljiha......",
".....eqqzqqzrqzqqozqozqqqozqoqzoqzoqqqoqozqpqoyoqpqnqnqnqnqjnjihc.......",
"......oqqzqozqozqzqqzqozqzqqzqqzqqzqzqzqpqoqzpqqnqopopopnlnjpjif........",
"......aqoqzqqzqqrqwqqqzqqozqqwqqwqqoqqozozpopoqnqnzpopnqnnlnjiha........",
".......hzqoqqozqwqqqwqqwqzqqzqqzqqzqzozpqqozqnqqvqnqnqnlnlnjjge.........",
"........jqzqzqqqqqwqqzqqqqzoqzqqozqoqqqqwqpqopwpqnqnpnpnjnjjif..........",
".........nqozqwqwqqqzoqzqwqqAqqAqqzqzqwqqpwqpqqnqnpolojpjljih...........",
".........copqoqqpqwpqqzoqqzqqwqqzqqzoqqqzoqpoqnqnqnpnpjnjnjec...........",
"..........coqpzoqqqozqqqzqqzqqzqozqqqzqopqqwpopopnmnjnljjiha............",
"...........cnqopznqzqozqozqozqqzqqwqqozpzopqnqnpopnlnjnjiha.............",
"............ajqnqqnqnqqoqqzqqozqoqqzoqpoqqnqnqnqnjpjnljif...............",
"..............jqnqpoqyoyqqoqzqoqzqoqpzoqnqnqpnpnlnjnjihe#...............",
"...............epnqnqopqopznqqpoqnzpoqpopopnopjnjpjjihc.................",
"................djnpnqnqpopqnqopopopopopnpopnjpjnjjgfa..................",
"..................fjpnpnqnqnqnpopqnpnqnpopjnlnjjjiga....................",
"....................fjnlnnponpnpnnpkpnjpjnlnjjjigb......................",
"......................cjjjnlnjpjnlnjnlnjjjjijge.........................",
".........................chijjjjjjjjjjijijgca...........................",
".............................ccefgegeedca...............................",
"........................................................................"
};

/* XPM */
static const char *pluto[] = {
/* width height num_colors chars_per_pixel */
"    89    72       27            1",
/* colors */
". c None",
"# c #000033",
"a c #003333",
"b c #000066",
"c c #003366",
"d c #333366",
"e c #006666",
"f c #336666",
"g c #000099",
"h c #003399",
"i c #333399",
"j c #006699",
"k c #336699",
"l c #666699",
"m c #339999",
"n c #669999",
"o c #3366cc",
"p c #6666cc",
"q c #3399cc",
"r c #6699cc",
"s c #9999cc",
"t c #66cccc",
"u c #99cccc",
"v c #cccccc",
"w c #99ccff",
"x c #ccccff",
"y c #ccffff",
/* pixels */
"........##babcbcb###b###b####.#####bc#b##b#babcbcb#b#b####bc##b####b#####................",
".........babcbcbabab#c##a#b########ab#c#abc#bab#baba#ab##a#bcb#abcbcc#b###...............",
"........#abccb#cb#ba######a########c###b#####b#c#####ba##b##bab#cbab#c#ab#...............",
"........##babccbab############a#.###bababa#c#cb#ba######a#ba##c#bcbcbbb#c................",
".......#c#bcccbb##a####a#a#.#a###aba##b###b#cbcba##c####ba####babcbc#c##b#.#.............",
".......##cb#cbc######ab#########a#b#c#cccbab#cb####b#a###b######c#b####c##.##............",
"......#.cb#ab##ba####cb#c###cb#b#babbbabcbcbccbab####b#c#c####ab#ba##c###.#a##...........",
"......###c####a##.#ab##c#b#abaccbabc#cccccbccccbc#c#ccbc#######cbabbabbc#....##..........",
"......b#a###########cbb##ab#bcbccbcccbcchccccccbb#bc#bab####a###bbccb#b#c................",
"...###c#bb####.#####cc###bc#cccbcccbcbccchchchccccbcbabcb#ab###a###babcbb#...............",
".#.#c#b#ab###.###.a#b#bababcchcccbcccchcccdchccchbccbbbcb######b######c##c.##............",
"...b#ccb#c##a##a##bab###cbccccchccbcccchbchcchchccccccbabcb###a##a####b#c####....#.......",
"...#cb#cba#b#####c###a#b#abcbbcchccbhccccccccccchcccbcbcbc#########c#c####.#..#..........",
"...babc#cbc###.######b###bcccccccchcbcchcbchchcechchcccbcbc########b#b##b................",
"...#bc#cb#cb#a###c#b#a#cbabcbbccbccccchccdcccchcheccccccbccb######aba##a##..#............",
"....#cbbcbbab#ba#bc##bcbcbcccccbchchccdchchchccdchcjhccbccbc#a##.b##b####b..#............",
"....#cbaba###c#bc#cbc#cbc#cbccbccccchcjcjcehfhehccchcchcbcbc#####a###c#####a##...........",
"....##cb#b#####cbb#abcbcbcbcbbcbccheiehkcjiehehehccccccbccbbb#c#####cb######b............",
".###c##c#c##a#babacbbc#bcb#bc#bachehejjhkjejhkjhehcchccbccccbab###.##ba###a#bc#..........",
".#ab###b##b#b#b#cbbccbcbaba#babcccheikjkekkjkjkchcjcccbcbcbcbbcb####c####b######.........",
"#..###abababa#abc#ccbcccbbbabcbcccchjkkkrkkkkkkjjcccbhcbbc#bccbc####b####c##b##cb........",
"..#babb#bb###bbabcbccbccbabbcbccchdjknrnrrpmpmokehcccccbcbc#bccbba#c#c##b#b#ab.###.......",
"..###c#c#a#b#abb#cbcccccbbabcccchcckkrrssrsrrrnkjhchccccbcbcbcbc#b##cb#b##abba#.#........",
"...a#bc#b##a####c#cccbchb#cccbchcjcmrssuuuustrlqkjchcchbcbcbcbcc##b#b#.ab#bc#b#..........",
".##bbabb######ab#bcbbcbbccbccccccjklrsuxvxvwssrkkjhcccccbc#bccbba####..#babb###..........",
".#ab##ccb######babbab#bacbcbchcccckmrsuxuxvxuurrkjehcbcccbcb#cb#####...###bab#a..........",
".###c#b#c#######ccb#babcb#cccchbcjklruvxvwvyvwskkkhehcbbcbbcbb##b#a...b..#ab.###.........",
"##c#babc###a#ab#bccb#cbc#b#ccccccjkkrsuxvyuxvurrkjjchcccbbabccba##........##..b#.........",
"###c#b####b###babcbabccbbabcchjckcjknruvwvxvwusrkjhehebcbcb#bcbb##.........#.#cba#.......",
"#ab##c#b#a###cbccbcb#bcb##cccchehjekosuuxvyuxsrqkjjhehccbbab#bcab#...........##.##.......",
"#b#b#cbab##c#bacbcbabab#c#bcccccjcjjknrsuxuxurrkkjiehccbcbcbabbba#...##......c#..........",
".#abc#b#bab#cbchcb#b#bcb#cbchbcchcjikkrsrusurrlqkjehcccbcbbc#bccbb#b#.#a......#..........",
".##c#c#cbb#babccbcbabc#cbbccccbccjcjjkmrrrrrnpmkjhjcjchbcbabc#cbcc##a...#...#..#.........",
".c##cb#bacb#babcccb##c##ba#bbcbcjcjkekkklrnprkokkjchcccbccbbcbccbbcb#######.#..#.........",
"###cb#c#hcbabcccccbc#b#b#bcbabcccjcjjjkkkkrnomkjjehehcbcbbccbccbcbc#bc######..#..........",
"...##cbcbcbc#bccgcb#b##c##cbcbcchcjckjjkjmokkkkjhehccccb##cbcbbc#c#bc#bcba#..###.........",
"...#.babccb#cbccccbc####bccbcccccchehjkjkjknokjjchejccb#cbcbcccbb#b#bcb#b#b..............",
"...#.#bccbab#cbbbcb###c##bcbccchchcccjejjkkkjjjcjchchbc#b#babbbab#cccbcc###c##...........",
"......#abcb#cba#cbab#####cbccbcchccjchjcjhjjkjcjcjccbcb##c#bc#bb##cbccb#b###cb#..........",
".....#.b#c####b#bcb#ab#cbbabccbccjcchecjhecjcjchehccbc#b#b#cb#c#c#bcbb##a##b#c#c#........",
".....#.a.#######ab######c#bcbccchcccchccjchchehchcccbc#bacbcbc##bcb#c#.bb##abbcb#........",
".........###c####b#b######b#cbcccchjchchcjcechccehccbb#cb####bcbab#cb..##..###b#c#.......",
".........#c##bc###abab###c#cbcchchcccjccehchcccccchcba#b#cbbab#cb#c##......##a####c.b#...",
".........##bc#b####cb#babcbbccbcccchccchcchcccchccbc#b##b#c#bc#b#cb#.........#..b#b#a#...",
".........#.cbc##ab##cb##bbacbccchcccchcchcccchbcbbb#c###ab##cbc#bb##.##a#......###a.#....",
"..........##b##b#cbcbab#abcbbbcbccbccchccccccccbc#cb#b####b#bcbcbab##cb##.....#..........",
"..........ababc#cbabbbabcbcbaccbbcchchccccbcbcbcbbab#c####a##cbc#bb###b#.................",
"......#..##bcccbccbccb#cbcbccbccccheccchcbcchbcbc#bb####c#bcbcbcbaba##c..................",
".......#.#abcbcccbccbcb#cbccchccccchchcccbcbccbc#b#a####bcbcccbccb#.##...................",
".........##c#cccbccbc#bcbcccjekjhjcchcbcbcbcccbb#########bcccbcbcb#......................",
"....#...#cb#cbchccbcbbabcbcjkkokkjjcccccbbcbbbc#ba####a##cbbcbcb#b##.....................",
"........#c#cbccchcbbacbcccjkkrnrkkkjhcbc##b#ab########b#b#cccbcbc#.......................",
"........##bcbcbccbcbcccchejkrrsrrrkjcccbba##bc#b####c###ccchcccb###..........#...........",
".........###bcbcbbabccbcchekrsuusrkkjcbccbbc######a####c#bccbcccb#a..........#...........",
"........#.#ab#cbc#bcbbccchkknusuurqjchb#b###b#####bb#cb#bcbcbbbb####.....................",
"..........#b#b##bcbcbcbcccjkrrusrrkhccb######abc#####bcbcbcbc#c##.##.....................",
"............#abc#bab#bccchehknrrrrjchbab##a#b#c#bc#c##cbcb##bc###..#.....................",
"........#...##b#b#bc#cbccchekkkrkkhcccb#a#b#cbbcb#bbc#cbcbc#c#.###.......................",
"............#..#a###b#cbccjcjkjkjehccbcbb#babcbccbc#bcbb####...#...#a#...................",
"................#.##.b#cchccjcjjchjccbbabab#cbcbbcbccb#a#b#.#......###...................",
"................#.#..#cbccccchccjcchccb#b#bcbaccbcbabcb#bc####b#...#a#...................",
"........#............#c#ccbcchehehecccbc#babbbbcb#bb###b##c#bc.#....#....................",
"...................#ab##cbcchchehjhccbcb#cbccbabc#abcb####b###....#a#....................",
"................#.#cb##bbcbcccchechchcbcbb#cbcbcbbbcb###a##a##....###....................",
"...................ba###ab#bcbccbcccbcb#c##cb#cbab#######b#bc##...##.....................",
"..................##b####bab#cbcbcbccb#b#c#bababb#a##a###a.###...........................",
".................#a###.##cb#babcb#bcbab#ab#b##bc##b#.##..##....#.........................",
"..................######b#ccb#b#cba#b##cb#######c#b#.#...#...............................",
"...................ba###ab#babcb#b#bc#bc#b#####b#c#......................................",
"....................#####..##c#bcb##b##c#####a#ab##......................................",
"......................###...##b#a#c########.####ba#.....#................................",
"...........................#aba#b##b#######a###ab#......................................."
};

/* XPM */
static const char *saturn[] = {
/* width height num_colors chars_per_pixel */
"    60    72       32            1",
/* colors */
". c None",
"# c #330000",
"a c #003300",
"b c #333300",
"c c #000033",
"d c #330033",
"e c #003333",
"f c #333333",
"g c #663333",
"h c #336633",
"i c #666633",
"j c #996633",
"k c #669933",
"l c #999933",
"m c #cc9933",
"n c #99cc33",
"o c #cccc33",
"p c #ffcc33",
"q c #ccff33",
"r c #ffff33",
"s c #333366",
"t c #663366",
"u c #666666",
"v c #996666",
"w c #669966",
"x c #999966",
"y c #cc9966",
"z c #99cc66",
"A c #cccc66",
"B c #ffcc66",
"C c #ccff66",
"D c #ffff66",
/* pixels */
"............................................................",
"........ffb.................................................",
".......biific...............................................",
".......fiuiiif..............................................",
".......fiuuuiii.............................................",
".......filufiiuif...........................................",
"........uuiiuiguif..........................................",
"........ilfvxwxifif.........................................",
"........fvhxjwjxwiif........................................",
"........buiuxjwvxviuf.......................................",
".........iujwvkvixwiih......................................",
".........fkixiviwivxiuf.....................................",
"..........uixvkuiiiulujf....................................",
"..........giuxiifffiuluif...................................",
"...........xixvifbdbguxiub..................................",
"...........fixiubf.fafixiub.................................",
"............xixufb.adbfixuie................................",
"............fulvhda...bfixii#.e#............................",
".............jukif#....ebuvuwuvwvwiff.......................",
".............huxvbe....fivwxjxlxlxvwuif.....................",
"..............iixida#auxxlxlxxxxlxxlxviuf...................",
"..............fivkf.fixlyxlyxlylyxyxxlwjuf..................",
"...............iuxidhxmxAmxxoxAxozmzxxxluii.................",
"...............fivifilyAoAylAynAyoxAylxxluuh#...............",
"................iixiflzmAAoxAoyoxAyoxyxlxxiufa..............",
".................wvwfiyAoAAoxyAAoyoAAzmxxlxiuf..............",
".................ulxiflAoApAmzoyAoAyAAxylxxviif.............",
"................fxvxiiiApAAAoyAoAxoAoAAxAlxluiff............",
"................ixxxviglABqBAoyoAAAoAyAoxylxxiub............",
"................uxxlxwiioABqBoAyoAoAAoAAyxlxlvisb...........",
"...............fxxyxxxjflBqBAooAAoyAoAyAAlAxxluif...........",
"...............fxxzyxxxiiAApDBAomAAoyAoAAylxlxjuf...........",
"...............fxxyAxlxxfjoDArAAoAoAAoAmAAyxxlxiie..........",
"...............hxxyAAyxxiixpCBpAoyAoAyoAmAAlxlvkub..........",
"...............gxxzyAzlxxiiApCBrAoyAoAmAAlAyxlxiig..........",
"...............fxxyzyAylxxglApCBoAoyoAAoyoynyxlvuh..........",
"...............fxxAxAAAyxxkgoABrBAoyAoyAoxoyzxlujh..........",
"...............fuxxAyAAAlxxiioBArBooyoAmzmAlylxlug..........",
"................xxxAxAyAAlxxgiCpADAoAlAoyzmxmxxjuh..........",
"................ixxyAyAAyAlxxglArApAoylAmAlynxlxig..........",
"................fuxxAxAAAmAxxiimABoBAoylAlylxlviuh..........",
".................ixxyzyAAAylxxiioAAoBoAlynylxllvif..........",
".................fxxxAxAyAzmxxxgiApAoAoylxlylxiiid..........",
"..................ixxxAxAmAAmxxxiloAoBAnylxlxjxif...........",
"..................fixxyxAxAyAlxxiglAoAmAmxlxluiuf...........",
"...................iuxxAxAyAxAlxxuilyoAmzmxjxiig............",
"....................ixlxyxxAAyylxxiglAlAmxllivif............",
"....................bfxxxxylyzyxlxviilylxmxluif.............",
".....................fgwxlxxAxAlxxxkgilxllxjii..............",
".......................iuxxxxxxyxlxvwgilvliiic..............",
"........................guxjxxlxxxjxxifiiiuf....iiub........",
".........................atukvxvlvxuxxiffif....fixui........",
"...........................bsiuiuwiujwxjf.......gwjuf.......",
"..........b...................ffffghfiuxifb....afixiu.......",
"......................................iuxif....#egwvkf......",
"......................................fiuxiff..bdhjxiu......",
".......................................bujxuhbdebfiwvif.....",
"........................................fiuluif#afivxiu.....",
".........................................fivxiihfgiwjulf....",
"..........................................fiuxviiiulxxui....",
"...........................................iiixxuluvkviub...",
"............................................fuixvwjwvxuvh...",
".............................................giixvxjwxuiu...",
"..............................................fuiuxxxvwivb..",
"...............................................fiiiuxxuiui..",
"................................................fiuififivi..",
".................................................bfuiiiuwi..",
"..................................................bfuiuviub.",
"....................................................fiiiuif.",
".....................................................ffiii..",
".......................................................dad..",
"............................................................"
};

/* XPM */
static const char *sun1[] = {
/* width height num_colors chars_per_pixel */
"    72    72       33            1",
/* colors */
". c None",
"# c #330000",
"a c #660000",
"b c #003300",
"c c #333300",
"d c #663300",
"e c #993300",
"f c #cc3300",
"g c #666600",
"h c #996600",
"i c #cc6600",
"j c #ff6600",
"k c #999900",
"l c #cc9900",
"m c #330033",
"n c #663333",
"o c #993333",
"p c #cc3333",
"q c #666633",
"r c #996633",
"s c #cc6633",
"t c #ff6633",
"u c #999933",
"v c #cc9933",
"w c #ff9933",
"x c #ffcc33",
"y c #cc9966",
"z c #ff9966",
"A c #cccc66",
"B c #ffcc66",
"C c #ff9999",
"D c #cccc99",
"E c #ffcc99",
/* pixels */
"........................................................................",
"..................................#.#...................................",
"............................#cdd#ddhdegdddd#............................",
"........................#cddedhehqedrehohedhddd.........................",
"......................cddhohrirerhherhehrhrerehdd#......................",
"....................dehoirihiririishirreiphshhohehdc....................",
"..................dhriririshshiriririihshshioihohreed#..................",
"................nshshshishsirsihsirirsishirirerihfrhohd.................",
"...............dhhshshsiririirississishshsirishshrihhodec...............",
".............#hrisisissisvissishsuisvirishsirihsirioihhrec..............",
"............drhsshssvivsvsslrvslsishsvsvsslsisshsiririohedd.............",
"...........#hiriisviririvivssisrlsvsisislrirvhsirihshshireed............",
"..........#gshsirlsivsvsvsislsvisvirlsvisslssvisirishirhfrgod...........",
"..........ehshsissvssvissvsusvsvsisvsslsvisvisrlsvishsirihehdd..........",
".........hrisirsvivslsvvivivsivivsvivssvhsssvisvirsviriririrehd.........",
"........deshsislssvsvssvssvsvssvsissskssvslsivisslsissihshrfren#........",
".......#hrisvrisvslssvivsvsvivisvsvhvslsvsivsvsvhsiriusiriirhhhd#.......",
".......hsirislsvsvsvivsvsvvsvsvsvivsissvisvssvhssvsvishsishioierc.......",
"......dhrisvsvsvisvsvsvslsslssivsvsvvsvsvvslsivslsissislsshshrheec......",
".....#hoisvivsvsvvsvsvivswsvsvsvisvsvslsvsvsvssvsvsvlsririsirirhed......",
".....drislssvsvsvswsvzvvsvvsvivsvslsslsvswsvivisvivssvivsvhsirierdd.....",
"....#hisssvsvsviwsvivvswvssvsvisvssvsvtvsivsssvssvsvvsvsisvsvirhsed#....",
"....drirlvyvivtvsvsvsvssvslswsvsivslsvsivsivvsvlsvvsvsvivsisvehohhrc....",
"....hsslsswsvsvsvvswvsvvsvsvissvvvsvtvsvsivsvisvsvwvtvsvsvvirssihred....",
"...dhsisvsvsvvsvswvsvsvivslsvvivswsvvslsvsvsvzvsvsvsvsvsvsvshvisirhoc...",
"...dsissivsvsvtvvsvsvtvssvssvsvsvsvsswsvsvvvvsvvsvsinhdddhshwsvrihehd...",
"..#hhsvsvsvivsvsltvvivsviwslswvsvwsvvvvsvsvswvswvslsvyevsrhzsvsisshod...",
"..coisivsvsvsvtvsvvswsvsvsvsvsvtvsvvwsvwszvvvzsvsvsvwywrsvsvsivshshhe#..",
"..dirvslsvsvslvsvswsvsvivsisvsvvivsvswyzvEvszvvswvvzywvvvsvsvvsihhsegc..",
"..erislsvsvswsvswsvsvsvsvsvslsisvswvzyByvBzAzyByzvssvyvsvswivsirdshhod..",
"..hhsisvsvsvsvtvsvsvivswsvvsvsvsvvsvvvwyzvvyvwyzvyvvswvswsvsslrdrihsdd..",
".#hsiussvivswivvslvtvsvslswivsvsswvzvsvvyvswyzAsywyzvvvsvsivsddsishehn..",
".cohsslsvsvivsvsvtvsvvslsvsssvslvsvzvzsvzshvvzEvyvBvEzsvsvsvhoivshshoh#.",
".chisisvivsvsvsvsvsvswsvsvslsivsswyyzAzvwrsvzACiywEEDBywslssivvshshshe#.",
".arhsvisvsvsvtvswsvsvsvsvivsvsivzyBEAzyzurByzyByyvyEECDyvslsvsisshishdc.",
".dhshsvssvslsvvvsvivsvivsssisvsvvByryvzrvzDzvzyxywvyBDBwsvssvivvishsrec.",
".ceisivslsvsvsswvsvwsvtvsvvvsvsvyEyrsvsACACvvvvsvywsvwsvsslsvssvshsihr#.",
".drhsrivsvsvtvivsvtvsvvsvisslsvszBEyBEyvzyBvwsvwvzvvsvsvsvsivsisvisuiec.",
".#hsivsvsvslsvsvsvsvvivtvvwsvsiwyByyvywAByBsvvzyyvswsvsvisvsvslrisrirh..",
".ceirivslsvsvsvivsvivtvsvsvsivvvvvzvsvzyzyzvvsvswvvsvsvsvslsivssvisire..",
".#rhssvssvsvslswsvswsvsvsivsvsssvsvwvsvzyxvywsvvswsvsvsvissvshsirirhir..",
".#hshivwvislswsvsvsvsvsvvswsvivvwvsvtvvvvswsvvswvvvvwswsvisisivhsivhod..",
"..ehshsvssvsvsvsvtvsvivswsvisvsssvsvvzvswsvvsvsvsvsvsvvsirhsusishssrh#..",
"..dhrisivsvissvsvvivsvswsvsvsvivsvvsvssvvsvsvtvvvtvvwsviddhsishvirhedc..",
"..cehshsvvsvslsviwsvsvivslsvisvslsswsvvswsvvsvvtvvsvsvsrersslsishired...",
"..#resissvwsvsivssvsvsvsvsvsvsivssvsvsvsvsvswvsvsvwsvwshrislsririrehd...",
"...dhhshsvsivsvsvsvivsswsvsvivsvsvslswislsvsvvvsvvsvsvogsivrslshshhoc...",
"...deriihsvsivsivsvsvtlsvivsvsvslsvsvsvssvsvswsvwswvrddsvsslshsihsed#...",
"...#hrhssisivsvsvisvsvsvsvtvisivswsvivsvsvtvvsvvsvsssvvsvivsisirihed....",
"....derihskshsvisvslsvslsvsvwvssvsvsvsvivsvswvswsvvslssvisshsirireq#....",
"....cehririssisvsivsslssvsvsvsvslsvivtvsvtvlsvsvvssvsvvsslsslrirhed.....",
".....derisirlslsvisvisvsvwswvvsvsvsvsvsvslssvsvsivsvsvivssivhshier#.....",
".....#dhhshsirsirisvsvslssvsvwvsvswsvslswsvvsvivsvtvwssivishsihohd......",
"......dohhshsisivshslsisvisvssvsivslsvsvsvsvsvswsvisvivsivsirireec......",
".......derihshvrishssvsvisvivvsvsslsvsvsvsvtlsvsvsvsvsivshshshhed.......",
".......cderihsisirivishsvisrisvivsvssvjvslsvsvsvivslsvsisishirenb.......",
"........dehoirigrisiuslssvirvissvisvivssvsvivsivssvsisiushshredc........",
"........#ndhhirasslrissishvevsvisvsvsslsvisssvssvisvsvisirihehc.........",
".........cdeoherhshssirlssirisvsvisivsvssvslsvivsvisisririrehn..........",
"..........#dgndihshishsirlrhslsisvsvisvivivsvivsisvirlirihehn...........",
"...........cadhrehshsirlsisisssvislsslsssvisssivsishshshered............",
"............cddeshshiririrhshvhssksshsvivisivisisksihshhohd.............",
"..............nehehoihshsirisishsislssvirshsshririshshehec..............",
"...............ddohhreihshiririshshshirsivirishsirhsehodc...............",
"................cddeehrehshshirisksishsiriririshrihehedc................",
".................#cndherehphirihhshriririhshirhihohodc..............#...",
"...................cddehohhhphhoireirhhirihshhphoddd....................",
".....................mcdheerherheirehphreheheehddd#...................#.",
".......................#cndedheerehehhehohoegnd#....................#...",
"..........................#cdnddddnhdneddddc#...........................",
"...............................#c#c#cc#c#...............................",
"........................................................................"
};

/* XPM */
static const char *uranus[] = {
/* width height num_colors chars_per_pixel */
"    72    72       35            1",
/* colors */
". c None",
"# c #003300",
"a c #000033",
"b c #003333",
"c c #003366",
"d c #333366",
"e c #006666",
"f c #336666",
"g c #003399",
"h c #006699",
"i c #336699",
"j c #009999",
"k c #339999",
"l c #0066cc",
"m c #3366cc",
"n c #0099cc",
"o c #3399cc",
"p c #6699cc",
"q c #9999cc",
"r c #33cccc",
"s c #66cccc",
"t c #99cccc",
"u c #cccccc",
"v c #99ffcc",
"w c #ccffcc",
"x c #3366ff",
"y c #3399ff",
"z c #6699ff",
"A c #9999ff",
"B c #33ccff",
"C c #66ccff",
"D c #99ccff",
"E c #ccccff",
"F c #99ffff",
"G c #ccffff",
/* pixels */
"........................................................................",
"........................................................................",
".................................a#a....................................",
"...........................bchilohmnmjmhecb.............................",
"........................chmomooomoomomommklieb..........................",
".....................aemoooooomoyoooooooomomlmhea.......................",
"....................hoooomzoypypozozoymoyomooommhea.....................",
"..................coomzozopypypypozozpypozooomoomohe....................",
"................bmoypypozpBpzpCpCpzpoCpypozoyooomommhb..................",
"...............coopozozszrzpCpyszsyszpzsypyppypyooomohc.................",
"..............hopypzszszpzszszszpCpCpCpzszsypypoymoomomh................",
".............iozozpBpzszsCzszszsCzszCpCszszpCpyppyooomohib..............",
"............mozozszpCpCpCpCCtzCDpDCsACpCpzszszsyppypyomolib.............",
"...........iozrzszsCpCCCqCtzCtzsDpCAsCCpCCzszpCpBzopoyoomnia............",
"..........hzrzpCpCzsCAsACCAsDCtCDCtCtztDztCpCCpzpszypooomohib...........",
".........cpypCpCpCpDzsDsDsDDpDDpDtzDCtCCtzsDpCzsCzpsypzoomole...........",
"........bozszszszDCtCDpDCqCtDsDDsDDsDAtzDsDzDsCzszszpypypyomme..........",
"........ozpCpCztCsACtDDsDDDDDDtDDCtDDsDDsDCtCqCtzszszsypyooomhc.........",
".......hppBpCpCCqCtCAsDDtDsDtCDDtDDtDDCtDDqCDCqCCAszCpzrpoxoomi#........",
"......aozszCpDsDCDDtDDtCDDDtDDtDDtDDCtDDDsDDsDCqCszszszpypopomnc........",
"......iCpzszDsACtAsDCtDDtDDDDDDtDDDtDDDtDDDsDqCDsACtzszszpyooomhb.......",
".....bozsCztCDsDDsDDDDDDDtDtDtDDDtDDDtDDtDDDDDtCDsDzsCzszrzoymomh.......",
".....izszsCDpDDsDDDtDtDtDDDDDFDtDDDtDDDDDtDtCDDtCAsDzszszpzpooomkba.....",
"....aoCpCAsDCtCDDtDDDDDDDtFuDtEFDwDFDuFtDDDDtDsDDtCtCAszszrzozomlh......",
"....epzsCsAsDDtDDDtDtDtFDEDDFEDtDDDEDDDDDtDDDDDtDCDztCDpCzpCopyomib.....",
"....msCztzDDsDDtDDDDDDDuDvDEtDFEDGtDwDtGDFtDtDDDtDtDCqCCpCpzpyooohc.....",
"...bpzsDztCtDDDDtDtDvEFDDEDvDEDvEDDGDDEDtEDFDtDDDDCtDCtztCpCopyomoi.....",
"...cCpCpDCDDsDtDDDDDDDtEFtEDGtDEDvEDtGDvDDEtDDtDtDtCDpDCpCzszpozomhb....",
"..bipCCDsDtDDDDtDDtGtEFDuDFDDEFtEDDwDDDEDwDDGDFDDDDtDDsDCqCpCypooomc....",
"...oCpDpDDCtDtDDDvEDDDuDFDEtGtDEFuDDEvEFDDFuDtDtDtDDsDDpDCpCpCozomne....",
"...pCztCDtDDDDDtEDDFuFDEDuFDDEFDDFEFDEDuDuDDFEDDDDDDDtCDszCpCpzooomi....",
"..bzsCDsDCtDtDDDFtEDDEDvDDEtDDuDuDDuFDwDFEFEtDGtDvDtDDtCAtCszpCozomna...",
"..bzCqCAtDDDDtDwDDFuDFuDEFDGDGDFEFEDEDDEDtEDFEtDEDDDtDCtCDpDpCpyoomib...",
"..cCpCtCDDtDDDDDEDEFuDDFDuDtDtEDtEvDwDGtGDFuDDDFtDtDDDtDCqCCzszpyoomc...",
"..fzDsDDtDDtDvEDvEtDDGDuDFEDGDFuFDEDEDEFDEDDGtEDEFDDtDDCtCtzszsypoome...",
"..hpCAsDCtDDDDDEDFEFEtDFEtDFtEDDEDvEFuFuDwDuDFEvDDtDDDtDDzDszszpypmnc...",
"..fCtCDtDDDtDGtFuDDtDGDEtGDEDDwDvEDEFDEDEDGDEtDDEtFEtDDsDsDzszszooome...",
"..gsAsDCDtDDDtEDDGDGDuDFDDuFuDDEDEFtEDvEFDtGDFEDvDDDDDtDDCtCAszpypome...",
"..dCCAtDDDtDGDDGtDuDGDEtGDDEFDGtFDEFEFEDuFEDEtFEDEtDvDDDsDpDszszoyome...",
"..csAsDCtDDDtDwDDGDDuFDEDwDDuDDEDwDuDuFEFEDvDEDtFDFDDDtDDsDzszszpoomc...",
"..bzsDCtDDtDGDDEDtGDDEvEDDGDFEvDEDGDGDEtDEFEDFuDEtEDtDDtCDsDzszpBoome...",
"..bpCDtDDDDDtEFtGDEvEFEDwDEtEDEFuDDuDFDGDwDuDEFDFDDtDDDDtDzsDzszozomb...",
"...pCACtDtDDFDEDDEFEDuFDEFDGDvEDFEFDGtEtEDDGDtEDuDGDDtDtCDtzszszoomob...",
"...msDsDDDtDuDvEvDuDFEDwDEtEDEFuDuDEDEFEFEvDEFDwDDtDFDDDtCDCpCpzozoha...",
"...fCzDtDDDDFDEDEDFEtGDDEFEFuFDEFEFtGtEFuDEDwDEDDFEtDtDtDCqCDpCpoomh....",
"...bztCDtDtDtEDvDEtGDEDwDuFDEDuFEtEFEDFEDFEFDEtFEtDDDDDDsDCpCpzrzooe....",
"....oDCtCDDDFDtEFDEDGtEDGDEtFEFEDFEDtGDuDEtEtFEDtDFDtDtDDsDpCszpyomb....",
"....iCqCDtDtEDFDuFDuDFEFDuFEDuDvEDuFEDEFEvDFEDDFEDtDDDDtCDpDzpCopmlb....",
"....bzDtDDDDtDEDDEFDGDtEDGDDGDGDEFDEFuFuDEFEDwDtDDGtDtDDsDCpCpzoyof.....",
".....oCDsDtDDFtGtDuDEFEFuDEvEDtEFuDwDDEFDEtDEDDEFtDDDDtCDpDCpCpyomb.....",
".....dszDDDDtDDDEFEFtEtEFDGDtGDGDEFEDGtEFDGDvEvDDEDtDDDtCDpCpzrpoha.....",
"......ytCtDtDDuFDtDEDGDFEtEDGDEtEvDEtEFDuDtEDDDEtDDDtDsDCpCpCpyome......",
"......fztCDDDDDDtGDFuDEtEFDwDEFEFEDGDDEDGDGDFuDFDtFtDDDsACtzszoom.......",
".......oCAsDtDtFDDuDDFDGDuDEFtEtDEvDuFEvDEtDEDtDDDDDDsDCtzszpypmc.......",
".......bztDCDDDDuDDGtEtDGDFEDEFEFDEDGDtEDFDEvDDFtDtDtDCqCszsypoh........",
"........iCsDtDtDDFDDDGDEtDEtFuDDuFEtDEFDuDuDDDtEDDDtCDsCzCpzoomb........",
".........oAsDDDtDtDuDDtFEFtEDFEFDEvDGDuDFDFDtGDDtDtCDsAsAszpyoe.........",
".........bpCDsDDDDDFtGDDDuFDEDtEtDEDtDFDEtDEDDtDDCDtCACszpBpoi..........",
"..........cpDCtDtDtDDDDuFDEDvEFDGDFEFEDtDEDvDDDtDtCDsCqCpCoom...........",
"...........csACtCDDDtDFDDtDDDDuDDtEtDtDGDtDDtDDDsDDpDzszpypmb...........",
"............csACDtDDDtDtEDFuDFDDwDDDFEDtDDDDDtDsDCtCpCpCoplb............",
".............csztCDtDDDDDtDDDtEDDDtDDtDDDvDtDDsDDszDszpzooa.............",
"..............bpCDsDCtDtDDDtFDtDtFDDtDDtDDDDsDDCpDszzsyoia..............",
"...............aiCAsDDtDDtDDtDDDDDtDDDDDtDsDDsCqCzCpsyph................",
".................foDpCDCtCDDDDtDtDDtDtDtCDDsACtCpCpzoob.................",
"..................aiCtztCDtCtDCDDtCDDCtCDsDCszzszpCod...................",
"....................biCztCztCtDsDCtCtCDsACpCqCpCpoi.....................",
"......................bfoAsCACpDsACtztzCsztzszpoea......................",
".........................cipszszCszCszszszsyofb.........................",
"............................abfikppppopiidb.............................",
"........................................................................",
"........................................................................"
};

/* XPM */
static const char *venus[] = {
/* width height num_colors chars_per_pixel */
"    64    72       41            1",
/* colors */
". c None",
"# c #330000",
"a c #003300",
"b c #333300",
"c c #000033",
"d c #330033",
"e c #003333",
"f c #333333",
"g c #663333",
"h c #336633",
"i c #666633",
"j c #996633",
"k c #cc6633",
"l c #669933",
"m c #999933",
"n c #cc9933",
"o c #333366",
"p c #663366",
"q c #336666",
"r c #666666",
"s c #996666",
"t c #cc6666",
"u c #669966",
"v c #999966",
"w c #cc9966",
"x c #ff9966",
"y c #99cc66",
"z c #cccc66",
"A c #ffcc66",
"B c #ccff66",
"C c #ffff66",
"D c #cc9999",
"E c #ff9999",
"F c #cccc99",
"G c #ffcc99",
"H c #ccff99",
"I c #ffff99",
"J c #cccccc",
"K c #ffcccc",
"L c #ccffcc",
"M c #ffffcc",
/* pixels */
"................................................................",
"...................................fbffada......................",
"...............................firirighgfffff...................",
"............................irvjvjsjrririoiffe#.................",
".........................brvsnvwsvvvjsiriifffffa................",
".......................brwvnwwwvwwmvvjvjrirghfffd...............",
"......................ivwwwwzwwzwvwwvvsvjriigfffeb..............",
"....................fvwwzwzzDzwzwwwwwmwsmrjrhphfffe.............",
"...................iwwzxzGwAzxzwzwzwvwvjsririfgffbda............",
"..................jwwzwFwzzDzwFwwwwvwvjvvjrirghfffed............",
".................vwzwzzxzEzxzwzwzwwvwvwjslsiiioiffbfa...........",
"................vwwzFxFzGzwFzxzwwzwwvnvvsjririgfhffedb..........",
"...............swzAFAFADzAzxFzDzwwzwwvwjvvjririfgfffbc..........",
"..............jzzFxzFxzAFwGzADAzwzwwwvwvsmssirirfhfffe#.........",
".............iwzxzGzGzGFAGzFAzDAFwzwwvwmwsvjvirgiffffbe.........",
"............fwzFGzGzGFAFAFAFAFAwzwwzwwwvwvmsrjirioiffeda........",
"............vwAwFAFAFAGzGzGzGwzGzGwzwzwwvwvmsvirigffffbd........",
"...........iwAFzAFAGGFAGFGAFAGFAwzwFwwwwvnsvjrjriiohffebc.......",
"..........bwwzwGFAFGzGFGAFGzGzADzGwzwzwvwvvvsmrirghgfff.f.......",
"..........szwGzGAGFGGzIzGzGzGzFAzwAwwwwzwvnsmsisiififfffa.......",
".........fwzFAGFGzGzIGzGGzGzADAwFzwzwzwvwwvvsjririoffffbda......",
".........jzDAFAFAGFAFAGFAFAFzAFzxzwwwwzwwvwjvvjrirgihfffed......",
"........bDzAFGzGFCGFGFAFAFAFADAwFwFzwzwwvwvwmsviriifgfffad......",
"........izGzGzGAFGzGAGHAFAFAFAzFAzxzwwwzwwmvsmsisiphfhfffa......",
"........wwFAFAFGzGGBGFAGFAFAFAFxzFwzDzwwvwvwvsmsirifrfff.f......",
".......fzAFAGFAFGCFGGAHGAFGGzGzGzxFxzwzwwvwjvssiriigffffff......",
".......iwFAFAGzGGFGAHGGFGIzGGzGzGzzzwzwwwvwvmvjvirirfiffada.....",
".......vAwGzGFGCFAIFGGHGGGGHAGzGzGwGwzwwvwvwsjvisiphgffffad.....",
".......wzGzGGAFGGHGGIFGIFIzGFGFAFAwzwwzwwvnsmvsiriighffffda.....",
"......fzGzGFGHGIGGIFGIGGIGGIGzGzAFzEzzDwwvwvvsjrjrioifffafc.....",
"......gzxFGAIGFAHGGIGFIFGFIFGGzGFAwzGwzwwvwmsmsmrirghffffbc.....",
"......iGzGGHGGIGGHGFIGIGIAFGCFGzAFAwzwzwzwvwvsmririfghfffeb.....",
"......vwGzIGFIFIGIKIGHGFGIGGFAGFAFzGwzxzwwwvnsvsiriiogffada.....",
"......vAFGGGIGIGLGIFIGIGHGHGIFAGzGzxFzDzwwwvvvjvjrighfffffc#....",
"......wzGGHGFIKIGIKIGKHGGGGFAGFIGzGzGzxzzwwvnsvjrirgqgffe#e.....",
"......wzGzGIGIFMGHGIFIGIGHGIGHAFAGzGwzFwwwwvwvjrjriifhffbfb.....",
"......wFGGIFIKIGMGMGMGIJIGIFGGGGzGzzGwAwzwvwvjvvjriphgfffcf.....",
"......wzGzGIGIKHMGHKIFIGIGGIFIFAFGGzGzwFwzwwvwsjririfffffada....",
"......vAFIGGLGIKIKIIKIGMFGHGGGIFGBGFAFAwzwwwvmvslrigifhfff......",
"......vzGGFIGIJIGIJIGLGGIGGIFIGGIGzGzxFzxzwwwwvjsiriofffbef.....",
"......jFAFIGIKIMHKIKIGMFIJIGIFGFAFGAFzADzwwywvvvjrighgfffda.....",
"......iwGGGHGIKIKIMIKIIKIGIFGIGIFAFAFAwzwzwwvnsjrjrhghfffad.....",
"......fAFAIGMFIKIKIJIMFMGIKIGFGFAGFAFzGwzwwwvvsmriiphfgfefa.....",
".......zGFGHGMGILIKIKIMGIJIFIGIGFAFAzxzwwwwvwmssirighgfff#f.....",
".......wzGGGIGLGMGMIMGMFMGIKIFGHAGzGzFwzwzvwvsmsirirffffef......",
".......iAFAHGIGMIKIJIKIMGIKIGIGGFGzGzxFwzwwvkvsisiigqghffad.....",
".......fzGFGGHKIGLGMGLGIKHGHGFIGIGFAFAzwwzwvvvjujrioiffff#e.....",
"........wzGzGIGHKIIKIIKHGIGIGGFGzGAFAFxFwwwwwvsjririffffeb......",
"........szGGGFIGIKIFMGIGMGHGIFIGGHAFAFzzwzwwvmvsmrighgffbc......",
"........bwzGHGGIFGIGIFMGHGGIFGGFAFAFAwAwzwwvwsjvirghphfefb......",
".........vGzGGFGIGHKIGIGGIJGIGFCFAFAFzDzwwwvvmsiriiffffbc.......",
".........fzAFAIFGIGGFIFIFGIGFGAGFAFzxzwwwwvwjvsjriphgffff.......",
"..........szGzGGFGFIGGGGIGFGCFGzGzADzwzwwvwvvjuirighfffac.......",
"..........fwzGzGAHAGHGHGFGCFGGzGzGzADzwwzvwjvsjrigqffff.f.......",
"...........jzwGzGzGFAGFAGFGzGzGzGzDzwzwwwvvvjsiriifgffeb........",
"............wzzGzGzGFAGFAFAGzGzGzAzxzwwwvwjvslsiphgfffbc........",
"............fwwzGzGzGzGzGzGzGzGzwFwzwwzwvwvjsirighfffebc........",
".............iFxzGzGzGzGzGzGzGzwAwzwwwvwvjsviriioghffbc.........",
"..............szwzxFAFAFAFAzFwAFwzDwzwvwsvjrjirghfffeda.........",
"...............vwzzxFAFAFAFAwAzwzwzwwvwvmsmririfgfffbc..........",
"...............#vwwFzwAzwAwFzDzxFwwwwwvmsvisirghfhfe#a..........",
".................vwwzxFwFzAwAwzwwzwvwvvtmsiriififff#e...........",
"..................vwwzwzwwDzwzwwzwwvwmvjsrjriphfffef............",
"...................iwwwwzwzwwwwwvwvwvsvsmririfgfff#.............",
"....................fvwwwzwwzwzwwvwvnvjvisiigqfffef.............",
"......................jywwzwwwwvwwvwvsmsjrirfifff...............",
".......................fswwwvzwwvwvmsmsririffffaf...............",
".........................fivwvvvvmsvjsiirifghff.................",
"...........................fgjsmssjririrfffff...................",
"..............................ffiiriiigfifff.a..................",
"..................................ffffffe#a.....................",
"................................................................"
};



int main() 
{
  graph G;

  node_array<double> xcoord;
  node_array<double> ycoord;
  grid_graph(G,xcoord,ycoord,4);

  while (G.number_of_nodes() > 12) G.del_node(G.first_node());

  GraphWin gw(G);

  window& W = gw.get_window();

  gw.set_bg_xpm(space_xpm);

  gw.set_node_shape(circle_node);
  gw.set_node_border_color(invisible);
  gw.set_node_shape(rectangle_node);
  gw.set_node_label_type(user_label);
  gw.set_node_label_pos(south_pos);
  gw.set_node_label_color(grey2);
  gw.set_node_color(invisible);
  gw.set_node_border_color(invisible);

  gw.set_edge_color(grey1);


  gw.set_position(xcoord,ycoord);
  gw.place_into_win();

  gw.display();
  gw.zoom(0.85);

  list<char*> L;

  L.append(W.create_pixrect(deep));
  L.append(W.create_pixrect(earth));
  L.append(W.create_pixrect(jupiter));
  L.append(W.create_pixrect(mars));
  L.append(W.create_pixrect(mercury));
  L.append(W.create_pixrect(moon));
  L.append(W.create_pixrect(neptune));
  L.append(W.create_pixrect(pluto));
  L.append(W.create_pixrect(saturn));
  L.append(W.create_pixrect(sun1));
  L.append(W.create_pixrect(uranus));
  L.append(W.create_pixrect(venus));


  list_item it = L.first();
  node v;
  forall_nodes(v,G) 
  { gw.set_pixmap(v,L[it]);
    gw.set_border_width(v,0);
    it = L.cyclic_succ(it);
   }

  gw.message("");

  
  gw.edit();

  return 0;
}

